from typing import Tuple, Set, Iterable, List


class GH_ColourSpace:
    #None = 0
    RGB = 1
    HSV = 2


class GH_ColourPickerEventArgs:
    @property
    def ColourPicker(self) -> GH_ColourPickerBase: ...
    @property
    def Colour(self) -> Color: ...
    @property
    def Original(self) -> Color: ...
    @property
    def Intermediate(self) -> bool: ...


class GH_ColourPickerBase:
    def __init__(self): ...
    def SetUiScaling(self, factor: Single) -> None: ...
    @property
    def Bounds(self) -> Rectangle: ...
    @Bounds.setter
    def Bounds(self, Value: Rectangle) -> None: ...
    @property
    def Padding(self) -> Padding: ...
    @Padding.setter
    def Padding(self, Value: Padding) -> None: ...
    @property
    def AutoSize(self) -> bool: ...
    @AutoSize.setter
    def AutoSize(self, Value: bool) -> None: ...
    @property
    def DrawChannelSliders(self) -> bool: ...
    @DrawChannelSliders.setter
    def DrawChannelSliders(self, Value: bool) -> None: ...
    @property
    def DrawAlphaSlider(self) -> bool: ...
    @DrawAlphaSlider.setter
    def DrawAlphaSlider(self, Value: bool) -> None: ...
    @property
    def DrawBackground(self) -> bool: ...
    @DrawBackground.setter
    def DrawBackground(self, Value: bool) -> None: ...
    @property
    def BackColour(self) -> Color: ...
    @BackColour.setter
    def BackColour(self, Value: Color) -> None: ...
    @property
    def BaseColour(self) -> Color: ...
    @property
    def PickColour(self) -> Color: ...
    @property
    def ColourSpace(self) -> GH_ColourSpace: ...
    @property
    def Font(self) -> Font: ...
    @Font.setter
    def Font(self, Value: Font) -> None: ...
    @overload
    def SetupColourPicker(self, col0: Color, col1: Color, space: GH_ColourSpace) -> None: ...
    @overload
    def SetupColourPicker(self, col0: Color, col1: Point4d, space: GH_ColourSpace) -> None: ...
    @property
    def BaseColourBox(self) -> Rectangle: ...
    @property
    def PickColourBox(self) -> Rectangle: ...
    @property
    def HSVSpaceBox(self) -> Rectangle: ...
    @property
    def RGBSpaceBox(self) -> Rectangle: ...
    @property
    def SRCSpaceBox(self) -> Rectangle: ...
    @property
    def DropperPreviewBox(self) -> Rectangle: ...
    @property
    def ColourCubeBox(self) -> Rectangle: ...
    @property
    def Cube(self) -> GH_ColourCube: ...
    @property
    def ChannelBox0(self) -> Rectangle: ...
    @property
    def ChannelBox1(self) -> Rectangle: ...
    @property
    def ChannelBox2(self) -> Rectangle: ...
    @property
    def ChannelBox3(self) -> Rectangle: ...
    @property
    def DesiredHeight(self) -> int: ...
    def add_Invalidated(self, obj: InvalidatedEventHandler) -> None: ...
    def remove_Invalidated(self, obj: InvalidatedEventHandler) -> None: ...
    def Invalidate(self) -> None: ...
    def add_ColorChanged(self, obj: ColorChangedEventHandler) -> None: ...
    def remove_ColorChanged(self, obj: ColorChangedEventHandler) -> None: ...
    def OnColorChanged(self, intermediate: bool) -> None: ...
    def MouseDown(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def MouseMove(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def MouseUp(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def MouseClick(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def MouseDoubleClick(self, args: MouseEventArgs, pt: PointF, owner: Control, transform: Matrix) -> bool: ...
    @property
    def IsTextInput(self) -> bool: ...
    def RespondToEnter(self) -> GH_ToolstripItemKeyHandlerResult: ...
    def RespondToEscape(self) -> GH_ToolstripItemKeyHandlerResult: ...
    def Render(self, G: Graphics) -> None: ...


class GH_ColourCube:
    def __init__(self, box: Rectangle, space: GH_ColourSpace, color: Point4d): ...
    @property
    def C0(self) -> Point: ...
    @property
    def C1(self) -> Point: ...
    @property
    def C2(self) -> Point: ...
    @property
    def C3(self) -> Point: ...
    @property
    def C4(self) -> Point: ...
    @property
    def C5(self) -> Point: ...
    @property
    def C6(self) -> Point: ...
    @property
    def C7(self) -> Point: ...
    @property
    def BottomFace(self) -> GraphicsPath: ...
    @property
    def LeftFace(self) -> GraphicsPath: ...
    @property
    def BackFace(self) -> GraphicsPath: ...
    @property
    def Silhouette(self) -> GraphicsPath: ...
    @property
    def Slice(self) -> Rectangle: ...
    @property
    def Pivot(self) -> Point: ...
    @property
    def Grip(self) -> Rectangle: ...
    @property
    def S0(self) -> Point: ...
    @property
    def S1(self) -> Point: ...
    @property
    def S2(self) -> Point: ...
    @property
    def S3(self) -> Point: ...
    @property
    def S4(self) -> Point: ...
    @property
    def Shadow(self) -> GraphicsPath: ...
    def ColorAtSlice(self, pt: PointF) -> Point4d: ...
    def ColorAtRail(self, pt: PointF) -> Point4d: ...
    def RenderAll(self, G: Graphics) -> None: ...
    def RenderBackFaces(self, G: Graphics) -> None: ...
    def RenderBackEdges(self, G: Graphics) -> None: ...
    def RenderForeEdges(self, G: Graphics) -> None: ...
    def RenderSilhouetteEdges(self, G: Graphics) -> None: ...
    def RenderDropShadow(self, G: Graphics) -> None: ...
    def RenderEdgeShadows(self, G: Graphics) -> None: ...
    def RenderSlice(self, G: Graphics) -> None: ...
    def RenderPivot(self, G: Graphics) -> None: ...
    def RenderGrip(self, G: Graphics) -> None: ...
    def RenderSliceEdgeShadows(self, G: Graphics) -> None: ...
    def RenderSliceDropShadow(self, G: Graphics) -> None: ...
    def RenderSliceSilhouetteEdges(self, G: Graphics) -> None: ...
    def Blend(self, A: Color, B: Color, t: float) -> Color: ...
    @overload
    def Average(self, A: Color, B: Color) -> Color: ...
    @overload
    def Average(self, A: Color, B: Color, C: Color, D: Color) -> Color: ...


class GH_ScrollBarVerticalBase:
    def __init__(self): ...
    @property
    def Minimum(self) -> int: ...
    @Minimum.setter
    def Minimum(self, Value: int) -> None: ...
    @property
    def Content(self) -> int: ...
    @Content.setter
    def Content(self, Value: int) -> None: ...
    @property
    def Display(self) -> int: ...
    @Display.setter
    def Display(self, Value: int) -> None: ...
    @property
    def Offset(self) -> int: ...
    @property
    def OffsetNormalised(self) -> float: ...
    @OffsetNormalised.setter
    def OffsetNormalised(self, Value: float) -> None: ...
    @property
    def ContentOffset(self) -> float: ...
    @overload
    def ScrollBar(self, rail: Rectangle) -> Rectangle: ...
    @overload
    def ScrollBar(self, rail: RectangleF) -> RectangleF: ...
    def BeginDrag(self, region: RectangleF, start: float) -> None: ...
    def ContinueDrag(self, position: float) -> bool: ...


class GH_DigitAlign:
    Justify = 0
    Left = 1
    Center = 2
    Right = 3


class GH_DigitScrollerEventArgs:
    @property
    def Scroller(self) -> GH_DigitScrollerBase: ...
    @property
    def Value(self) -> Decimal: ...
    @property
    def Intermediate(self) -> bool: ...


class GH_DigitNumber:
    @overload
    def __init__(self, decimalPlaces: int): ...
    @overload
    def __init__(self, decimalPlaces: int, radixPosition: int): ...
    @overload
    def __init__(self, other: GH_DigitNumber): ...
    @property
    def Value(self) -> Decimal: ...
    @Value.setter
    def Value(self, Value: Decimal) -> None: ...
    @property
    def Epsilon(self) -> Decimal: ...
    def ToString(self) -> str: ...
    @property
    def DigitCount(self) -> int: ...
    @property
    def Radix(self) -> int: ...
    @Radix.setter
    def Radix(self, Value: int) -> None: ...
    @property
    def RadixIndex(self) -> int: ...
    @property
    def PrimaryPositive(self) -> bool: ...
    @PrimaryPositive.setter
    def PrimaryPositive(self, Value: bool) -> None: ...
    @property
    def SecondaryPositive(self) -> bool: ...
    @property
    def Offset(self) -> Decimal: ...
    @property
    def PrimaryDigits(self) -> List[int]: ...
    @property
    def SecondaryDigits(self) -> List[int]: ...
    @property
    def Maximum(self) -> Decimal: ...
    @Maximum.setter
    def Maximum(self, Value: Decimal) -> None: ...
    @property
    def Minimum(self) -> Decimal: ...
    @Minimum.setter
    def Minimum(self, Value: Decimal) -> None: ...
    @property
    def IsPrimaryDigitSignificant(self, index: int) -> bool: ...
    @property
    def IsSecondaryDigitSignificant(self, index: int) -> bool: ...
    def Reset(self) -> None: ...
    def AssignOffset(self, index: int, offset: Decimal) -> bool: ...
    def Round(self) -> None: ...
    def LimitValue(self) -> None: ...


class GH_DigitScrollerBase(GH_TextBoxInputBase):
    def __init__(self): ...
    def SetupScroller(self, minimum: Decimal, maximum: Decimal, value: Decimal) -> None: ...
    @property
    def Value(self) -> Decimal: ...
    @Value.setter
    def Value(self, Value: Decimal) -> None: ...
    @property
    def Epsilon(self) -> Decimal: ...
    @property
    def Digits(self) -> int: ...
    @Digits.setter
    def Digits(self, Value: int) -> None: ...
    @property
    def Radix(self) -> int: ...
    @Radix.setter
    def Radix(self, Value: int) -> None: ...
    @property
    def DecimalPlaces(self) -> int: ...
    @DecimalPlaces.setter
    def DecimalPlaces(self, Value: int) -> None: ...
    @property
    def MinimumValue(self) -> Decimal: ...
    @MinimumValue.setter
    def MinimumValue(self, Value: Decimal) -> None: ...
    @property
    def MaximumValue(self) -> Decimal: ...
    @MaximumValue.setter
    def MaximumValue(self, Value: Decimal) -> None: ...
    @property
    def EdgeColour(self) -> Color: ...
    @EdgeColour.setter
    def EdgeColour(self, Value: Color) -> None: ...
    @property
    def TopColour(self) -> Color: ...
    @TopColour.setter
    def TopColour(self, Value: Color) -> None: ...
    @property
    def BottomColour(self) -> Color: ...
    @BottomColour.setter
    def BottomColour(self, Value: Color) -> None: ...
    @property
    def TextColour(self) -> Color: ...
    @TextColour.setter
    def TextColour(self, Value: Color) -> None: ...
    @property
    def RailColour(self) -> Color: ...
    @RailColour.setter
    def RailColour(self, Value: Color) -> None: ...
    @property
    def ShadowColour(self) -> Color: ...
    @ShadowColour.setter
    def ShadowColour(self, Value: Color) -> None: ...
    @property
    def ShadowSize(self) -> Padding: ...
    @ShadowSize.setter
    def ShadowSize(self, Value: Padding) -> None: ...
    @property
    def BackgroundGradient(self) -> GH_Gradient: ...
    @BackgroundGradient.setter
    def BackgroundGradient(self, Value: GH_Gradient) -> None: ...
    @property
    def DrawBorder(self) -> bool: ...
    @DrawBorder.setter
    def DrawBorder(self, Value: bool) -> None: ...
    @property
    def DrawShadows(self) -> bool: ...
    @DrawShadows.setter
    def DrawShadows(self, Value: bool) -> None: ...
    @property
    def DrawBackground(self) -> bool: ...
    @DrawBackground.setter
    def DrawBackground(self, Value: bool) -> None: ...
    @property
    def AmplifyMotion(self) -> bool: ...
    @AmplifyMotion.setter
    def AmplifyMotion(self, Value: bool) -> None: ...
    @property
    def AllowRadixDrag(self) -> bool: ...
    @AllowRadixDrag.setter
    def AllowRadixDrag(self, Value: bool) -> None: ...
    @property
    def AllowTextInput(self) -> bool: ...
    @AllowTextInput.setter
    def AllowTextInput(self, Value: bool) -> None: ...
    @property
    def Font(self) -> Font: ...
    @Font.setter
    def Font(self, Value: Font) -> None: ...
    @property
    def Bounds(self) -> Rectangle: ...
    @Bounds.setter
    def Bounds(self, Value: Rectangle) -> None: ...
    @property
    def DigitAlign(self) -> GH_DigitAlign: ...
    @DigitAlign.setter
    def DigitAlign(self, Value: GH_DigitAlign) -> None: ...
    @property
    def Prefix(self) -> str: ...
    @Prefix.setter
    def Prefix(self, Value: str) -> None: ...
    @property
    def Suffix(self) -> str: ...
    @Suffix.setter
    def Suffix(self, Value: str) -> None: ...
    @property
    def ScrollBoxes(self) -> List: ...
    @property
    def RadixBox(self) -> Rectangle: ...
    @property
    def SignBox(self) -> Rectangle: ...
    @property
    def PrefixBox(self) -> Rectangle: ...
    @property
    def SuffixBox(self) -> Rectangle: ...
    @property
    def RaiseEvents(self) -> bool: ...
    @RaiseEvents.setter
    def RaiseEvents(self, Value: bool) -> None: ...
    def add_Invalidated(self, obj: InvalidatedEventHandler) -> None: ...
    def remove_Invalidated(self, obj: InvalidatedEventHandler) -> None: ...
    def OnInvalidated(self) -> None: ...
    def add_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def remove_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def OnValueChanged(self, intermediate: bool) -> None: ...
    def MouseDown(self, args: MouseEventArgs, pt: PointF) -> GH_MouseAction: ...
    def MouseMove(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def MouseUp(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    @overload
    def ShowTextInputBox(self, owner: Control) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, limitToBoundary: bool) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, limitToBoundary: bool, transform: Matrix) -> None: ...
    def Render(self, G: Graphics) -> None: ...


class GH_SliderAccuracy:
    Float = 0
    Integer = 1
    Even = 2
    Odd = 3


class GH_SliderRailDisplay:
    #None = 0
    Simple = 1
    Etched = 2
    Filled = 3


class GH_SliderGripDisplay:
    #None = 0
    Numeric = 1
    Shape = 2
    ShapeAndText = 3


class GH_SliderTickDisplay:
    #None = 0
    Simple = 1
    Etched = 2


class GH_SliderEventArgs:
    @property
    def Slider(self) -> GH_SliderBase: ...
    @property
    def Value(self) -> Decimal: ...
    @property
    def Intermediate(self) -> bool: ...


class SliderSnapRange:
    @overload
    def __init__(self, value: Decimal): ...
    @overload
    def __init__(self, value0: Decimal, value1: Decimal): ...
    @property
    def Min(self) -> Decimal: ...
    @property
    def Max(self) -> Decimal: ...
    @property
    def IsSingleton(self) -> bool: ...
    def DistanceTo(self, value: Decimal) -> Decimal: ...
    def SnapValue(self, value: Decimal) -> Decimal: ...
    def CanMerge(self, other: SliderSnapRange) -> bool: ...
    def Merge(self, other: SliderSnapRange) -> SliderSnapRange: ...
    def CompareTo(self, other: SliderSnapRange) -> int: ...


class GH_SliderBase(GH_TextBoxInputBase):
    def __init__(self): ...
    def MouseDown(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def MouseMove(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def MouseUp(self, args: MouseEventArgs, pt: PointF) -> bool: ...
    def KeyDown(self, args: KeyEventArgs) -> bool: ...
    @overload
    def ShowTextInputBox(self, owner: Control) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, limitToBoundary: bool) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, limitToBoundary: bool, transform: Matrix) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, limitToBoundary: bool, transform: Matrix, content: str) -> None: ...
    @property
    def TextInputHandlerDelegate(self) -> TextInputHandler: ...
    @TextInputHandlerDelegate.setter
    def TextInputHandlerDelegate(self, AutoPropertyValue: TextInputHandler) -> None: ...
    @property
    def RenderDelegate_Background(self) -> DrawSliderChannel: ...
    @RenderDelegate_Background.setter
    def RenderDelegate_Background(self, Value: DrawSliderChannel) -> None: ...
    @property
    def RenderDelegate_Ticks(self) -> DrawSliderChannel: ...
    @RenderDelegate_Ticks.setter
    def RenderDelegate_Ticks(self, Value: DrawSliderChannel) -> None: ...
    @property
    def RenderDelegate_Rail(self) -> DrawSliderChannel: ...
    @RenderDelegate_Rail.setter
    def RenderDelegate_Rail(self, Value: DrawSliderChannel) -> None: ...
    @property
    def RenderDelegate_Grip(self) -> DrawSliderChannel: ...
    @RenderDelegate_Grip.setter
    def RenderDelegate_Grip(self, Value: DrawSliderChannel) -> None: ...
    @property
    def RenderDelegate_Border(self) -> DrawSliderChannel: ...
    @RenderDelegate_Border.setter
    def RenderDelegate_Border(self, Value: DrawSliderChannel) -> None: ...
    def Render(self, G: Graphics) -> None: ...
    @property
    def ControlBackColour(self) -> Color: ...
    @ControlBackColour.setter
    def ControlBackColour(self, Value: Color) -> None: ...
    @property
    def ControlEdgeColour(self) -> Color: ...
    @ControlEdgeColour.setter
    def ControlEdgeColour(self, Value: Color) -> None: ...
    @property
    def ControlShadowColour(self) -> Color: ...
    @ControlShadowColour.setter
    def ControlShadowColour(self, Value: Color) -> None: ...
    @property
    def GripTopColour(self) -> Color: ...
    @GripTopColour.setter
    def GripTopColour(self, Value: Color) -> None: ...
    @property
    def GripBottomColour(self) -> Color: ...
    @GripBottomColour.setter
    def GripBottomColour(self, Value: Color) -> None: ...
    @property
    def GripEdgeColour(self) -> Color: ...
    @GripEdgeColour.setter
    def GripEdgeColour(self, Value: Color) -> None: ...
    @property
    def TextColour(self) -> Color: ...
    @TextColour.setter
    def TextColour(self, Value: Color) -> None: ...
    @property
    def RailFullColour(self) -> Color: ...
    @RailFullColour.setter
    def RailFullColour(self, Value: Color) -> None: ...
    @property
    def RailEmptyColour(self) -> Color: ...
    @RailEmptyColour.setter
    def RailEmptyColour(self, Value: Color) -> None: ...
    @property
    def RailDarkColour(self) -> Color: ...
    @RailDarkColour.setter
    def RailDarkColour(self, Value: Color) -> None: ...
    @property
    def RailBrightColour(self) -> Color: ...
    @RailBrightColour.setter
    def RailBrightColour(self, Value: Color) -> None: ...
    @property
    def Font(self) -> Font: ...
    @Font.setter
    def Font(self, Value: Font) -> None: ...
    @property
    def FormatMask(self) -> str: ...
    @FormatMask.setter
    def FormatMask(self, Value: str) -> None: ...
    @property
    def RailDisplay(self) -> GH_SliderRailDisplay: ...
    @RailDisplay.setter
    def RailDisplay(self, Value: GH_SliderRailDisplay) -> None: ...
    @property
    def GripDisplay(self) -> GH_SliderGripDisplay: ...
    @GripDisplay.setter
    def GripDisplay(self, Value: GH_SliderGripDisplay) -> None: ...
    @property
    def TickDisplay(self) -> GH_SliderTickDisplay: ...
    @TickDisplay.setter
    def TickDisplay(self, Value: GH_SliderTickDisplay) -> None: ...
    @property
    def DrawControlBackground(self) -> bool: ...
    @DrawControlBackground.setter
    def DrawControlBackground(self, Value: bool) -> None: ...
    @property
    def DrawControlBorder(self) -> bool: ...
    @DrawControlBorder.setter
    def DrawControlBorder(self, Value: bool) -> None: ...
    @property
    def DrawControlShadows(self) -> bool: ...
    @DrawControlShadows.setter
    def DrawControlShadows(self, Value: bool) -> None: ...
    @property
    def TickCount(self) -> int: ...
    @TickCount.setter
    def TickCount(self, Value: int) -> None: ...
    @property
    def TickFrequency(self) -> int: ...
    @TickFrequency.setter
    def TickFrequency(self, Value: int) -> None: ...
    @property
    def ShadowSize(self) -> Padding: ...
    @ShadowSize.setter
    def ShadowSize(self, Value: Padding) -> None: ...
    @property
    def Bounds(self) -> Rectangle: ...
    @Bounds.setter
    def Bounds(self, Value: Rectangle) -> None: ...
    @property
    def Padding(self) -> Padding: ...
    @Padding.setter
    def Padding(self, Value: Padding) -> None: ...
    @property
    def GripWidth(self) -> int: ...
    @property
    def Grip(self) -> RectangleF: ...
    @property
    def Rail(self) -> Rectangle: ...
    @property
    def Ticks(self) -> List: ...
    @property
    def Type(self) -> GH_SliderAccuracy: ...
    @Type.setter
    def Type(self, Value: GH_SliderAccuracy) -> None: ...
    @property
    def DecimalPlaces(self) -> int: ...
    @DecimalPlaces.setter
    def DecimalPlaces(self, Value: int) -> None: ...
    @property
    def Minimum(self) -> Decimal: ...
    @Minimum.setter
    def Minimum(self, Value: Decimal) -> None: ...
    @property
    def Maximum(self) -> Decimal: ...
    @Maximum.setter
    def Maximum(self, Value: Decimal) -> None: ...
    @property
    def Value(self) -> Decimal: ...
    @Value.setter
    def Value(self, Value: Decimal) -> None: ...
    @property
    def ValueF(self) -> Single: ...
    @ValueF.setter
    def ValueF(self, Value: Single) -> None: ...
    @property
    def NormalizedValue(self) -> float: ...
    @NormalizedValue.setter
    def NormalizedValue(self, Value: float) -> None: ...
    @property
    def RaiseEvents(self) -> bool: ...
    @RaiseEvents.setter
    def RaiseEvents(self, Value: bool) -> None: ...
    @property
    def Epsilon(self) -> Decimal: ...
    @property
    def GripText(self) -> str: ...
    @property
    def GripTextPure(self) -> str: ...
    @property
    def SnapDistance(self) -> Decimal: ...
    @SnapDistance.setter
    def SnapDistance(self, AutoPropertyValue: Decimal) -> None: ...
    def SetSnapRanges(self, ranges: Iterable[SliderSnapRange]) -> None: ...
    def FixDomain(self) -> None: ...
    def FixValue(self) -> None: ...
    def ProcessNumber(val: Decimal, accuracy: GH_SliderAccuracy, digits: int) -> Decimal: ...
    def add_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def remove_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def OnValueChanged(self, intermediate: bool) -> None: ...


class GH_TextBoxInputBase:
    @property
    def Bounds(self) -> Rectangle: ...
    @Bounds.setter
    def Bounds(self, Value: Rectangle) -> None: ...
    @property
    def Font(self) -> Font: ...
    @Font.setter
    def Font(self, Value: Font) -> None: ...
    @property
    def IsTextInput(self) -> bool: ...
    def HideTextInputBox(self) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, content: str, selectContent: bool) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, content: str, selectContent: bool, limitToBoundary: bool) -> None: ...
    @overload
    def ShowTextInputBox(self, owner: Control, content: str, selectContent: bool, limitToBoundary: bool, transform: Matrix) -> None: ...
    def RespondToEnter(self) -> GH_ToolstripItemKeyHandlerResult: ...
    def RespondToEscape(self) -> GH_ToolstripItemKeyHandlerResult: ...


class InvalidatedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class ColorChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_ColourPickerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_ColourPickerEventArgs) -> None: ...


class InvalidatedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class ValueChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DigitScrollerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DigitScrollerEventArgs) -> None: ...


class GH_MouseAction:
    #None = 0
    SignDown = 1
    DigitDown = 2
    DigitDrag = 3
    RadixDown = 4
    RadixDrag = 5


class DrawSliderChannel:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, slider: GH_SliderBase, G: Graphics, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, slider: GH_SliderBase, G: Graphics) -> None: ...


class ValueChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_SliderEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_SliderEventArgs) -> None: ...


class TextInputHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, slider: GH_SliderBase, text: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, slider: GH_SliderBase, text: str) -> None: ...
