from typing import Tuple, Set, Iterable, List


class GH_MessageWidget(GH_Widget):
    def __init__(self): ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    def add_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    def remove_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    def add_WidgetLevelChanged(obj: WidgetLevelChangedEventHandler) -> None: ...
    def remove_WidgetLevelChanged(obj: WidgetLevelChangedEventHandler) -> None: ...
    @property
    def SharedVisible() -> bool: ...
    @SharedVisible.setter
    def SharedVisible(Value: bool) -> None: ...
    @property
    def Visible(self) -> bool: ...
    @Visible.setter
    def Visible(self, Value: bool) -> None: ...
    def Contains(self, pt_control: Point, pt_canvas: PointF) -> bool: ...
    def Render(self, canvas: GH_Canvas) -> None: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_AlignWidget(GH_Widget):
    def __init__(self): ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def TooltipText(self) -> str: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def add_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    def remove_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    @property
    def SharedVisible() -> bool: ...
    @SharedVisible.setter
    def SharedVisible(Value: bool) -> None: ...
    @property
    def Visible(self) -> bool: ...
    @Visible.setter
    def Visible(self, Value: bool) -> None: ...
    def Contains(self, pt_control: Point, pt_canvas: PointF) -> bool: ...
    def Render(self, canvas: GH_Canvas) -> None: ...


class GH_MarkovWidgetDock:
    TopLeft = 0
    BottomLeft = 1
    TopRight = 2
    BottomRight = 3


class GH_MarkovWidget(GH_Widget):
    def __init__(self): ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    def Contains(self, pt_control: Point, pt_canvas: PointF) -> bool: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    def AppendToMenu(self, menu: ToolStripDropDownMenu) -> None: ...
    def add_IconLimitChanged(obj: IconLimitChangedEventHandler) -> None: ...
    def remove_IconLimitChanged(obj: IconLimitChangedEventHandler) -> None: ...
    @property
    def IconLimit() -> int: ...
    @IconLimit.setter
    def IconLimit(Value: int) -> None: ...
    def add_DockCornerChanged(obj: DockCornerChangedEventHandler) -> None: ...
    def remove_DockCornerChanged(obj: DockCornerChangedEventHandler) -> None: ...
    @property
    def DockCorner() -> GH_MarkovWidgetDock: ...
    @DockCorner.setter
    def DockCorner(Value: GH_MarkovWidgetDock) -> None: ...
    def add_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    def remove_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    @property
    def SharedVisible() -> bool: ...
    @SharedVisible.setter
    def SharedVisible(Value: bool) -> None: ...
    @property
    def Visible(self) -> bool: ...
    @Visible.setter
    def Visible(self, Value: bool) -> None: ...
    def Render(self, Canvas: GH_Canvas) -> None: ...


class GH_ProfilerWidget(GH_Widget):
    def __init__(self): ...
    def AppendToMenu(self, menu: ToolStripDropDownMenu) -> None: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def TooltipText(self) -> str: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    def add_ShowDurationChanged(obj: ShowDurationChangedEventHandler) -> None: ...
    def remove_ShowDurationChanged(obj: ShowDurationChangedEventHandler) -> None: ...
    @property
    def ShowDuration() -> bool: ...
    @ShowDuration.setter
    def ShowDuration(Value: bool) -> None: ...
    def add_ProfilerThresholdChanged(obj: ProfilerThresholdChangedEventHandler) -> None: ...
    def remove_ProfilerThresholdChanged(obj: ProfilerThresholdChangedEventHandler) -> None: ...
    @property
    def Threshold() -> int: ...
    @Threshold.setter
    def Threshold(Value: int) -> None: ...
    def add_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    def remove_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    @property
    def SharedVisible() -> bool: ...
    @SharedVisible.setter
    def SharedVisible(Value: bool) -> None: ...
    @property
    def Visible(self) -> bool: ...
    @Visible.setter
    def Visible(self, Value: bool) -> None: ...
    def Contains(self, pt_control: Point, pt_canvas: PointF) -> bool: ...
    def Render(self, Canvas: GH_Canvas) -> None: ...


class IGH_Widget:
    @property
    def Owner(self) -> GH_Canvas: ...
    @Owner.setter
    def Owner(self, Value: GH_Canvas) -> None: ...
    @property
    def Visible(self) -> bool: ...
    @Visible.setter
    def Visible(self, Value: bool) -> None: ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def TooltipText(self) -> str: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    def Render(self, Canvas: GH_Canvas) -> None: ...
    def Contains(self, pt_control: Point, pt_canvas: PointF) -> bool: ...
    def AppendToMenu(self, menu: ToolStripDropDownMenu) -> None: ...


class GH_Widget:
    @property
    def Owner(self) -> GH_Canvas: ...
    @Owner.setter
    def Owner(self, Value: GH_Canvas) -> None: ...
    @property
    def Visible(self) -> bool: ...
    @Visible.setter
    def Visible(self, Value: bool) -> None: ...
    def Render(self, Canvas: GH_Canvas) -> None: ...
    def Contains(self, pt_control: Point, pt_canvas: PointF) -> bool: ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    @property
    def TooltipText(self) -> str: ...
    def AppendToMenu(self, menu: ToolStripDropDownMenu) -> None: ...
    def RespondToKeyDown(self, sender: GH_Canvas, e: KeyEventArgs) -> GH_ObjectResponse: ...
    def RespondToKeyUp(self, sender: GH_Canvas, e: KeyEventArgs) -> GH_ObjectResponse: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def IsTooltipRegion(self, canvas_coordinate: PointF) -> bool: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    @property
    def TooltipEnabled(self) -> bool: ...


class GH_CanvasWidget_FixedObject(GH_Widget):
    def ControlLocation(self, vp: GH_Viewport) -> Point: ...
    def CanvasLocation(self, vp: GH_Viewport) -> PointF: ...
    def Render(self, canvas: GH_Canvas) -> None: ...
    @property
    def Ratio(self) -> SizeF: ...
    @Ratio.setter
    def Ratio(self, Value: SizeF) -> None: ...
    @property
    def Size(self) -> Size: ...
    @property
    def Padding(self) -> int: ...


class GH_CompassWidget(GH_CanvasWidget_FixedObject):
    def __init__(self): ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    @property
    def Radius(self) -> int: ...
    @property
    def Size(self) -> Size: ...
    @property
    def Padding(self) -> int: ...
    def Contains(self, pt_control: Point, pt_canvas: PointF) -> bool: ...
    @property
    def Ratio(self) -> SizeF: ...
    @Ratio.setter
    def Ratio(self, Value: SizeF) -> None: ...
    def AppendToMenu(self, menu: ToolStripDropDownMenu) -> None: ...
    def RespondToKeyDown(self, sender: GH_Canvas, e: KeyEventArgs) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def add_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    def remove_WidgetVisibleChanged(obj: WidgetVisibleChangedEventHandler) -> None: ...
    @property
    def SharedVisible() -> bool: ...
    @SharedVisible.setter
    def SharedVisible(Value: bool) -> None: ...
    @property
    def Visible(self) -> bool: ...
    @Visible.setter
    def Visible(self, Value: bool) -> None: ...
    def add_WidgetDrawModeChanged(obj: WidgetDrawModeChangedEventHandler) -> None: ...
    def remove_WidgetDrawModeChanged(obj: WidgetDrawModeChangedEventHandler) -> None: ...
    @property
    def DrawObjects() -> bool: ...
    @DrawObjects.setter
    def DrawObjects(Value: bool) -> None: ...
    @property
    def DrawSelectionOnly() -> bool: ...
    @DrawSelectionOnly.setter
    def DrawSelectionOnly(Value: bool) -> None: ...


class WidgetVisibleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class WidgetLevelChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class WidgetVisibleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class IconLimitChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class DockCornerChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class WidgetVisibleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class ShowDurationChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class ProfilerThresholdChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class WidgetVisibleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class WidgetVisibleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class WidgetDrawModeChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...
