from typing import Tuple, Set, Iterable, List


class GH_AsynchFileData:
    def __init__(self, filePath: str, thumbnail: bool, callback: FileChangedDelegate): ...
    def UpdatePropertiesAsynch(self) -> None: ...
    def UpdateProperties(self) -> None: ...
    def StartPeriodicUpdate(self) -> None: ...
    def StopPeriodicUpdate(self) -> None: ...
    @property
    def Thumbnail(self) -> bool: ...
    @Thumbnail.setter
    def Thumbnail(self, AutoPropertyValue: bool) -> None: ...
    @property
    def Callback(self) -> FileChangedDelegate: ...
    @Callback.setter
    def Callback(self, AutoPropertyValue: FileChangedDelegate) -> None: ...
    @property
    def IsFileData(self) -> bool: ...
    @property
    def FileSize(self) -> Int64: ...
    @property
    def FileExists(self) -> bool: ...
    @property
    def FileCreated(self) -> DateTime: ...
    @property
    def FileLastChanged(self) -> DateTime: ...
    @property
    def FileThumbnail(self) -> Bitmap: ...
    def Dispose(self) -> None: ...


class GH_AutoSaveLastChanceForm:
    def __init__(self): ...
    @property
    def RecoveryAction(self) -> GH_FileRecoveryAction: ...


class GH_FileRecoveryAction:
    #None = 0
    OpenRecoveryFile = 1
    SaveRecoveryFile = 2
    DeleteRecoveryFile = 3


class GH_EtoUtil:
    def CenterFormOnCursor(F: Window, limitToScreen: bool) -> None: ...
    def CenterFormOnEditor(F: Window, limitToScreen: bool) -> None: ...
    def CenterFormOnWindow(F: Window, parentWindow: Window, limitToScreen: bool) -> None: ...
    def CenterFormOnScreen(F: Window, limitToScreen: bool) -> None: ...


class GH_WindowsFormUtil:
    def CenterFormOnCursor(F: Form, limitToScreen: bool) -> None: ...
    def CenterFormOnEditor(F: Form, limitToScreen: bool) -> None: ...
    def CenterFormOnWindow(F: Form, parentWindow: Form, limitToScreen: bool) -> None: ...
    def CenterFormOnScreen(F: Form, limitToScreen: bool) -> None: ...


class GH_PruderyFilter:
    #None = 0
    Low = 1
    Medium = 2
    High = 3
    Total = 4
    Unset = -1


class GH_ClusterPasswordWindow:
    def __init__(self): ...


class GH_ColourPicker:
    def __init__(self): ...
    @property
    def AllowNumericInput(self) -> bool: ...
    @AllowNumericInput.setter
    def AllowNumericInput(self, Value: bool) -> None: ...
    @property
    def Colour(self) -> Color: ...
    @Colour.setter
    def Colour(self, Value: Color) -> None: ...
    @property
    def ShowChannelSliders(self) -> bool: ...
    @ShowChannelSliders.setter
    def ShowChannelSliders(self, Value: bool) -> None: ...
    @property
    def ShowAlphaSlider(self) -> bool: ...
    @ShowAlphaSlider.setter
    def ShowAlphaSlider(self, Value: bool) -> None: ...
    @property
    def SliceRectangle(self) -> Rectangle: ...
    @property
    def DesiredHeight(self) -> int: ...
    def add_ColourChanged(self, obj: ColourChangedEventHandler) -> None: ...
    def remove_ColourChanged(self, obj: ColourChangedEventHandler) -> None: ...
    def RespondToEnter(self) -> GH_ToolstripItemKeyHandlerResult: ...
    def RespondToEscape(self) -> GH_ToolstripItemKeyHandlerResult: ...


class GH_ColourSwatchControl(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def Colour(self) -> Color: ...
    @Colour.setter
    def Colour(self, Value: Color) -> None: ...
    def add_ColourChanged(self, obj: ColourChangedEventHandler) -> None: ...
    def remove_ColourChanged(self, obj: ColourChangedEventHandler) -> None: ...


class GH_ColourSwatchEventArgs:
    def __init__(self, colour: Color): ...
    @property
    def Colour(self) -> Color: ...


class GH_ComponentAggregateForm:
    def __init__(self): ...
    def PushProxy(self, proxy: IGH_ObjectProxy) -> None: ...
    def PopProxy(self) -> IGH_ObjectProxy: ...
    @property
    def ProxyCount(self) -> int: ...


class GH_ComponentInfoForm:
    def __init__(self): ...
    def SetupMarker(self, control: Control, target: Rectangle, type: GH_MarkerType) -> None: ...
    @property
    def MarkerType(self) -> GH_MarkerType: ...


class GH_MarkerType:
    DocumentObject = 0
    RibbonTab = 1
    RibbonIcon = 2


class GH_ControlKnobOptionsForm:
    def __init__(self): ...
    @property
    def Modified(self) -> bool: ...
    @property
    def KnobName(self) -> str: ...
    @KnobName.setter
    def KnobName(self, Value: str) -> None: ...
    @property
    def DisplayFormat(self) -> str: ...
    @DisplayFormat.setter
    def DisplayFormat(self, Value: str) -> None: ...
    @property
    def Value(self) -> Decimal: ...
    @Value.setter
    def Value(self, Value: Decimal) -> None: ...
    @property
    def MinimumValue(self) -> Decimal: ...
    @MinimumValue.setter
    def MinimumValue(self, Value: Decimal) -> None: ...
    @property
    def MaximumValue(self) -> Decimal: ...
    @MaximumValue.setter
    def MaximumValue(self, Value: Decimal) -> None: ...
    @property
    def Range(self) -> Decimal: ...
    @Range.setter
    def Range(self, Value: Decimal) -> None: ...
    @property
    def Decimals(self) -> int: ...
    @Decimals.setter
    def Decimals(self, Value: int) -> None: ...
    @property
    def LimitValue(self) -> bool: ...
    @LimitValue.setter
    def LimitValue(self, Value: bool) -> None: ...


class GH_ControlKnobValueEditor:
    def __init__(self): ...
    @property
    def tblLayout(self) -> TableLayoutPanel: ...
    @tblLayout.setter
    def tblLayout(self, WithEventsValue: TableLayoutPanel) -> None: ...
    def SetupValues(self, limit: bool, lower: Decimal, upper: Decimal, value: Decimal, decimals: int) -> None: ...
    @property
    def LowerLimit(self) -> Decimal: ...
    @property
    def UpperLimit(self) -> Decimal: ...
    @property
    def Value(self) -> Decimal: ...
    @property
    def Limited(self) -> bool: ...
    @property
    def OriginalLowerLimit(self) -> Decimal: ...
    @property
    def OriginalUpperLimit(self) -> Decimal: ...
    @property
    def OriginalValue(self) -> Decimal: ...
    def add_ValuesChanged(self, obj: ValuesChangedEventHandler) -> None: ...
    def remove_ValuesChanged(self, obj: ValuesChangedEventHandler) -> None: ...
    def PrepareForCancel(self) -> None: ...
    def PrepareForCommit(self) -> None: ...


class GH_CustomButtonRunCode:


class GH_CustomButtonRequireFilter:


class GH_CustomButton:
    def __init__(self): ...
    @property
    def Name(self) -> str: ...
    @Name.setter
    def Name(self, Value: str) -> None: ...
    @property
    def Description(self) -> str: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @property
    def Icon(self) -> Bitmap: ...
    @Icon.setter
    def Icon(self, Value: Bitmap) -> None: ...
    @property
    def RunCode(self) -> str: ...
    @RunCode.setter
    def RunCode(self, Value: str) -> None: ...
    @property
    def RequireCode(self) -> str: ...
    @RequireCode.setter
    def RequireCode(self, Value: str) -> None: ...
    @property
    def UseCustomRequirementCode(self) -> bool: ...
    @UseCustomRequirementCode.setter
    def UseCustomRequirementCode(self, Value: bool) -> None: ...
    @property
    def RequireDocument(self) -> bool: ...
    @RequireDocument.setter
    def RequireDocument(self, Value: bool) -> None: ...
    @property
    def RequireObjects(self) -> bool: ...
    @RequireObjects.setter
    def RequireObjects(self, Value: bool) -> None: ...
    @property
    def RequireSelection(self) -> bool: ...
    @RequireSelection.setter
    def RequireSelection(self, Value: bool) -> None: ...
    @property
    def RunCodeInstance(self) -> GH_CustomButtonRunCode: ...
    @property
    def RequireCodeInstance(self) -> GH_CustomButtonRequireFilter: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class GH_DataTreeGraphic:
    def __init__(self): ...


class GH_DataTreeBranchGraphic:
    def __init__(self): ...
    def RenderFullBranch(self, graphics: Graphics, colour: Color) -> None: ...
    def RenderPartialBranch(self, graphics: Graphics, colour: Color) -> None: ...


class GH_DebugLogForm:
    def __init__(self): ...


class GH_ExternalFileConflictDialog:
    def __init__(self): ...
    @property
    def InfoLabel(self) -> Label: ...
    @InfoLabel.setter
    def InfoLabel(self, WithEventsValue: Label) -> None: ...
    @property
    def FilePathA(self) -> str: ...
    @FilePathA.setter
    def FilePathA(self, Value: str) -> None: ...
    @property
    def FilePathB(self) -> str: ...
    @FilePathB.setter
    def FilePathB(self, Value: str) -> None: ...
    @property
    def LoadFileCode(self) -> int: ...


class GH_ExternalFilePanel(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def File(self) -> str: ...
    @File.setter
    def File(self, Value: str) -> None: ...
    def add_FileLoadClicked(self, obj: FileLoadClickedEventHandler) -> None: ...
    def remove_FileLoadClicked(self, obj: FileLoadClickedEventHandler) -> None: ...
    def add_FileDeleteClicked(self, obj: FileDeleteClickedEventHandler) -> None: ...
    def remove_FileDeleteClicked(self, obj: FileDeleteClickedEventHandler) -> None: ...


class GH_FontControl:
    def __init__(self): ...
    @property
    def AllowFamilyOverride(self) -> bool: ...
    @AllowFamilyOverride.setter
    def AllowFamilyOverride(self, Value: bool) -> None: ...
    @property
    def AllowStyleOverride(self) -> bool: ...
    @AllowStyleOverride.setter
    def AllowStyleOverride(self, Value: bool) -> None: ...
    @property
    def AllowSizeOverride(self) -> bool: ...
    @AllowSizeOverride.setter
    def AllowSizeOverride(self, Value: bool) -> None: ...


class GH_FontList(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def Filter(self) -> str: ...
    @Filter.setter
    def Filter(self, Value: str) -> None: ...
    @property
    def DisplayText(self) -> str: ...
    @DisplayText.setter
    def DisplayText(self, Value: str) -> None: ...
    @property
    def FontSize(self) -> Single: ...
    @FontSize.setter
    def FontSize(self, Value: Single) -> None: ...
    @property
    def FontStyle(self) -> FontStyle: ...
    @FontStyle.setter
    def FontStyle(self, Value: FontStyle) -> None: ...
    @property
    def FontFamily(self) -> FontFamily: ...
    @FontFamily.setter
    def FontFamily(self, Value: FontFamily) -> None: ...
    def CreateFont(self) -> Font: ...
    def RecreateFontList(self) -> None: ...


class GH_FontPicker:
    def __init__(self): ...
    @property
    def SelectedFont(self) -> Font: ...
    @SelectedFont.setter
    def SelectedFont(self, Value: Font) -> None: ...
    @overload
    def ShowFontPickerWindow(font: Font) -> Font: ...
    @overload
    def ShowFontPickerWindow(font: Font, parent: Form) -> Font: ...
    def CreateFontPickerWindow(defaultFont: Font) -> Form: ...


class GH_FontScroller(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def PostPaintDelegate(self) -> PostPaint: ...
    @PostPaintDelegate.setter
    def PostPaintDelegate(self, Value: PostPaint) -> None: ...


class GH_GeometricFont:
    @property
    def Char0() -> GraphicsPath: ...
    @property
    def Char1() -> GraphicsPath: ...
    @property
    def Char2() -> GraphicsPath: ...
    @property
    def Char3() -> GraphicsPath: ...
    @property
    def Char4() -> GraphicsPath: ...
    @property
    def Char5() -> GraphicsPath: ...
    @property
    def Char6() -> GraphicsPath: ...
    @property
    def Char7() -> GraphicsPath: ...
    @property
    def Char8() -> GraphicsPath: ...
    @property
    def Char9() -> GraphicsPath: ...
    @property
    def CharDash() -> GraphicsPath: ...
    @property
    def CharSemiColon() -> GraphicsPath: ...
    @property
    def CharBracketOpen() -> GraphicsPath: ...
    @property
    def CharBracketClose() -> GraphicsPath: ...
    def Draw0(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw1(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw2(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw3(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw4(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw5(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw6(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw7(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw8(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def Draw9(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def DrawSemiColon(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def DrawDash(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def DrawBracketOpen(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def DrawBracketClose(graphics: Graphics, colour: Color, position: PointF) -> None: ...
    def DrawPath(graphics: Graphics, path: GH_Path, colour: Color, position: PointF) -> None: ...
    @overload
    def DrawNumber(graphics: Graphics, number: int, colour: Color, position: PointF) -> None: ...
    @overload
    def DrawNumber(graphics: Graphics, number: UInt32, colour: Color, position: PointF) -> None: ...
    @overload
    def DrawNumber(graphics: Graphics, number: Int64, colour: Color, position: PointF) -> None: ...
    @overload
    def DrawNumber(graphics: Graphics, number: UInt64, colour: Color, position: PointF) -> None: ...


class GH_GooProxyList(GH_DoubleBufferedPanel):
    def __init__(self): ...
    def SetData(self, data: GH_Structure, baseType: IGH_Goo) -> None: ...
    def GetData(self) -> GH_Structure: ...
    @property
    def SelectedData(self) -> List: ...
    def add_SelectionChanged(self, obj: SelectionChangedEventHandler) -> None: ...
    def remove_SelectionChanged(self, obj: SelectionChangedEventHandler) -> None: ...
    def add_DataChanged(self, obj: DataChangedEventHandler) -> None: ...
    def remove_DataChanged(self, obj: DataChangedEventHandler) -> None: ...


class GH_LoadProtectDialog:
    def __init__(self): ...
    def SetAssemblyName(self, name: str) -> None: ...


class GH_MenuCustomControl:
    def __init__(self, dropdown: ToolStripDropDown, control: Control, lockFocus: bool, width: int): ...
    def add_KeyDown(self, obj: KeyDownEventHandler) -> None: ...
    def remove_KeyDown(self, obj: KeyDownEventHandler) -> None: ...
    @property
    def Control(self) -> Control: ...
    @property
    def CommitItem(self) -> ToolStripMenuItem: ...
    @property
    def CancelItem(self) -> ToolStripMenuItem: ...
    def CloseEntireMenuStructure(self) -> None: ...


class GH_MenuShortcut:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, itemPath: str): ...
    @overload
    def __init__(self, itemPath: str, shortcut: Keys, shortcutText: str): ...
    @property
    def ItemPath(self) -> str: ...
    @ItemPath.setter
    def ItemPath(self, Value: str) -> None: ...
    @property
    def ItemHierarchy(self) -> Set(str): ...
    @property
    def Shortcut(self) -> Keys: ...
    @Shortcut.setter
    def Shortcut(self, Value: Keys) -> None: ...
    @property
    def ShortcutText(self) -> str: ...
    @ShortcutText.setter
    def ShortcutText(self, Value: str) -> None: ...
    def ApplyToMenu(self, menu: MenuStrip, filter: Iterable[ToolStripMenuItem]) -> ToolStripMenuItem: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class GH_MeshingParametersFrontEnd:
    def __init__(self): ...
    def add_MeshingParametersChanged(self, obj: MeshingParametersChangedEventHandler) -> None: ...
    def remove_MeshingParametersChanged(self, obj: MeshingParametersChangedEventHandler) -> None: ...
    @property
    def Parameters(self) -> MeshingParameters: ...
    @Parameters.setter
    def Parameters(self, Value: MeshingParameters) -> None: ...


class GH_MeshingParametersEventArgs:
    def __init__(self, parameters: MeshingParameters): ...
    @property
    def MeshingParameters(self) -> MeshingParameters: ...


class GH_MessageMustReadWindow:
    def __init__(self): ...
    @property
    def Delay(self) -> int: ...
    @Delay.setter
    def Delay(self, Value: int) -> None: ...
    @property
    def Title(self) -> str: ...
    @Title.setter
    def Title(self, Value: str) -> None: ...
    @property
    def Content(self) -> str: ...
    @Content.setter
    def Content(self, Value: str) -> None: ...


class GH_NamedViewMenuItem(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def View(self) -> GH_NamedView: ...
    @View.setter
    def View(self, Value: GH_NamedView) -> None: ...
    @property
    def Document(self) -> GH_Document: ...
    @Document.setter
    def Document(self, Value: GH_Document) -> None: ...
    @property
    def Canvas(self) -> GH_Canvas: ...
    @Canvas.setter
    def Canvas(self, Value: GH_Canvas) -> None: ...
    @property
    def ApplyRegion(self) -> Rectangle: ...
    @property
    def DeleteRegion(self) -> Rectangle: ...
    @property
    def LabelRegion(self) -> Rectangle: ...


class GH_NumberSliderSnappingEditor:
    def __init__(self): ...
    @property
    def SnapLines(self) -> List: ...


class GH_PanelEditorControl:
    def __init__(self): ...
    @property
    def PanelProperties(self) -> GH_PanelProperties: ...
    @PanelProperties.setter
    def PanelProperties(self, Value: GH_PanelProperties) -> None: ...
    @property
    def PanelContent(self) -> str: ...
    @PanelContent.setter
    def PanelContent(self, Value: str) -> None: ...
    def PickNewFont(self) -> None: ...


class GH_PasswordBox:
    def __init__(self): ...
    @property
    def Password(self) -> str: ...
    @Password.setter
    def Password(self, Value: str) -> None: ...
    @property
    def Key(self) -> Set(Byte): ...
    @Key.setter
    def Key(self, Value: Set(Byte)) -> None: ...
    def add_ValidPasswordEntered(self, obj: ValidPasswordEnteredEventHandler) -> None: ...
    def remove_ValidPasswordEntered(self, obj: ValidPasswordEnteredEventHandler) -> None: ...


class GH_QuickImageEditor:
    def __init__(self): ...
    @property
    def CanvasImage(self) -> Bitmap: ...
    @CanvasImage.setter
    def CanvasImage(self, AutoPropertyValue: Bitmap) -> None: ...
    @property
    def ViewportImage(self) -> Bitmap: ...
    @ViewportImage.setter
    def ViewportImage(self, AutoPropertyValue: Bitmap) -> None: ...
    @property
    def FrameCrop(self) -> Rectangle: ...
    @FrameCrop.setter
    def FrameCrop(self, AutoPropertyValue: Rectangle) -> None: ...
    @property
    def FrameFocus(self) -> Rectangle3d: ...
    @FrameFocus.setter
    def FrameFocus(self, AutoPropertyValue: Rectangle3d) -> None: ...
    @property
    def FrameViewport(self) -> Rectangle3d: ...
    @FrameViewport.setter
    def FrameViewport(self, AutoPropertyValue: Rectangle3d) -> None: ...
    @property
    def ViewportName(self) -> str: ...
    @ViewportName.setter
    def ViewportName(self, AutoPropertyValue: str) -> None: ...


class GH_DragDropImageRenderer:
    def __init__(self): ...
    def Dispose(self) -> None: ...
    @property
    def ImageList(self) -> ImageList: ...
    @ImageList.setter
    def ImageList(self, Value: ImageList) -> None: ...
    @property
    def Owner(self) -> Control: ...
    @Owner.setter
    def Owner(self, Value: Control) -> None: ...
    @overload
    def StartDrag(self, imageIndex: int) -> None: ...
    @overload
    def StartDrag(self, imageIndex: int, xOffset: int, yOffset: int) -> None: ...
    def CompleteDrag(self) -> None: ...
    def PaintDragDropImage(self) -> None: ...
    def HideDragDropImage(self, hide: bool) -> None: ...


class GH_ParamViewerForm:
    def __init__(self): ...
    @property
    def Canvas(self) -> GH_Canvas: ...
    @Canvas.setter
    def Canvas(self, Value: GH_Canvas) -> None: ...
    @property
    def AutoUpdateOnPick(self) -> bool: ...
    @AutoUpdateOnPick.setter
    def AutoUpdateOnPick(self, Value: bool) -> None: ...


class GH_AnimatedProcessPanel(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def ParticleCount(self) -> int: ...
    @ParticleCount.setter
    def ParticleCount(self, Value: int) -> None: ...
    @property
    def Particles(self) -> List: ...
    @property
    def ParticleDirections(self) -> List: ...
    @property
    def ParticleSpeed(self) -> float: ...
    @ParticleSpeed.setter
    def ParticleSpeed(self, Value: float) -> None: ...
    @property
    def PaintDelegate(self) -> GH_PaintDelegate: ...
    @PaintDelegate.setter
    def PaintDelegate(self, Value: GH_PaintDelegate) -> None: ...
    @property
    def OverlayDelegate(self) -> GH_PaintDelegate: ...
    @OverlayDelegate.setter
    def OverlayDelegate(self, Value: GH_PaintDelegate) -> None: ...
    def BezierPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def MetaballPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def DelaunayPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def CirclePaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def VoronoiPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def kdTreePaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def ProximityPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def DeformPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def SyrpinskiPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def OildropPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def FeynmanDiagramPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def BugColonyPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def LightConePaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def PoincareDiscPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def ParticleDusterPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def CodeBreakerPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def OrreryPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def HilbertCurvePaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def VennDiagramPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def EulerTrianglePaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def GaussianPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def CharacterTumblePaintDelegate(control: Control, e: PaintEventArgs) -> None: ...
    def PrismPaintDelegate(control: Control, e: PaintEventArgs) -> None: ...


class GH_RibbonLayoutEditor(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def RibbonLayout(self) -> GH_Layout: ...
    @RibbonLayout.setter
    def RibbonLayout(self, Value: GH_Layout) -> None: ...
    def ClearUndo(self) -> None: ...
    def RecordUndo(self) -> None: ...
    def Undo(self) -> None: ...
    def Redo(self) -> None: ...
    @property
    def UndoCount(self) -> int: ...
    @property
    def RedoCount(self) -> int: ...
    def add_UndoRedoChanged(self, obj: UndoRedoChangedEventHandler) -> None: ...
    def remove_UndoRedoChanged(self, obj: UndoRedoChangedEventHandler) -> None: ...


class GH_RibbonLayoutEditorUndoRedoEventArgs:
    def __init__(self, owner: GH_RibbonLayoutEditor): ...
    @property
    def Editor(self) -> GH_RibbonLayoutEditor: ...
    @property
    def UndoCount(self) -> int: ...
    @property
    def RedoCount(self) -> int: ...


class GH_RibbonLayoutEditorDialog:
    def __init__(self): ...


class GH_RotationalFrame:
    @property
    def Pivot(self) -> PointF: ...
    @Pivot.setter
    def Pivot(self, AutoPropertyValue: PointF) -> None: ...
    @property
    def Point(self) -> PointF: ...
    @Point.setter
    def Point(self, AutoPropertyValue: PointF) -> None: ...
    @property
    def Angle(self) -> float: ...
    @Angle.setter
    def Angle(self, AutoPropertyValue: float) -> None: ...
    @property
    def Time(self) -> DateTime: ...
    @Time.setter
    def Time(self, AutoPropertyValue: DateTime) -> None: ...




class GH_SamplingSphere:
    def __init__(self, size: int): ...
    @property
    def Size(self) -> int: ...
    @property
    def SampleCount(self) -> int: ...
    @overload
    def SampleSphere(self, sphere: Sphere) -> Point2d[,]: ...
    @overload
    def SampleSphere(self, sphere: Sphere, texture: GH_MemoryBitmap) -> Bitmap: ...


class GH_SettingsGUI:
    def __init__(self): ...


class IGH_SettingCategory:
    @property
    def Parent(self) -> str: ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...


class GH_SettingsCategory:
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Name(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Parent(self) -> str: ...


class IGH_SettingFrontend:
    @property
    def Category(self) -> str: ...
    @property
    def Name(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    def SettingsUI(self) -> Control: ...


class GH_DisplaySettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_SolverSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_AuthorSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_ViewportSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_InterfaceSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_FontsSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_PaletteSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_WidgetsSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_FilesSettingsCategory(GH_SettingsCategory):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...


class GH_RibbonSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_FormattingSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_DefaultPreviewSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_DocumentPreviewSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_GumballAndMeshingSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_TemplatePathSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_SolverSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_GHALoadSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_AuthorSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_AutoSaveSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_MRUSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CanvasOverlaySettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CanvasZuiSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_TooltipWiggleSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_FontStandardSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_FontScriptSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_FontConsoleSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_PruderySettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_ComponentMenuSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_MenuShortcutSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_AlignWidgetSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_MarkovWidgetSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_ProfilerWidgetSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CompassWidgetSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_MessagesWidgetSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CapsuleStandardPaletteSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CapsuleHiddenPaletteSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CapsuleDisabledPaletteSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CapsuleWarningPaletteSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_CapsuleErrorPaletteSettingsUI:
    def __init__(self): ...
    @property
    def Category(self) -> str: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    def SettingsUI(self) -> Control: ...


class GH_StandardIcons:
    @property
    def UnknownObjectIcon_24x24() -> Bitmap: ...
    @property
    def BlankParameterIcon_24x24() -> Bitmap: ...
    @property
    def BlankObjectIcon_24x24() -> Bitmap: ...
    @property
    def UserObjectIcon_24x24() -> Bitmap: ...
    @property
    def ClusterIcon_24x24() -> Bitmap: ...
    @property
    def GroupIcon_24x24() -> Bitmap: ...
    @property
    def FlattenIcon_24x24() -> Bitmap: ...
    @property
    def GraftIcon_24x24() -> Bitmap: ...
    @property
    def FileIconGH_32x36() -> Bitmap: ...
    @property
    def FileIconGHMissing_32x36() -> Bitmap: ...
    @property
    def FileIconGHX_32x36() -> Bitmap: ...
    @property
    def FileIconGHXMissing_32x36() -> Bitmap: ...
    @property
    def FileIconDll_32x32() -> Bitmap: ...
    @property
    def FileIconExe_32x32() -> Bitmap: ...
    @property
    def FileIconGha_32x32() -> Bitmap: ...
    @property
    def FileIconRhp_32x32() -> Bitmap: ...


class GH_TextInputBaseControl:
    def __init__(self): ...
    @property
    def IsTextInputActive(self) -> bool: ...
    @property
    def ShowTextInputOnKeyDown(self) -> bool: ...
    @ShowTextInputOnKeyDown.setter
    def ShowTextInputOnKeyDown(self, Value: bool) -> None: ...
    @property
    def ShowTextInputOnDoubleClick(self) -> bool: ...
    @ShowTextInputOnDoubleClick.setter
    def ShowTextInputOnDoubleClick(self, Value: bool) -> None: ...


class GH_UnrecognizedObjectsForm:
    def __init__(self): ...


class GH_UpgradeComponentControl(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def Document(self) -> GH_Document: ...
    @Document.setter
    def Document(self, Value: GH_Document) -> None: ...
    @property
    def Upgraders(self) -> List: ...
    def PopulateTooltip(self, sender: Object, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_UpgradeComponentForm:
    def __init__(self): ...


class GH_UpgradeUndoWarningDialog:
    def __init__(self): ...


class GH_DigitScroller(GH_TextInputBaseControl):
    def __init__(self): ...
    @property
    def MinimumValue(self) -> Decimal: ...
    @MinimumValue.setter
    def MinimumValue(self, Value: Decimal) -> None: ...
    @property
    def MaximumValue(self) -> Decimal: ...
    @MaximumValue.setter
    def MaximumValue(self, Value: Decimal) -> None: ...
    @property
    def Value(self) -> Decimal: ...
    @Value.setter
    def Value(self, Value: Decimal) -> None: ...
    @property
    def Epsilon(self) -> Decimal: ...
    @property
    def Digits(self) -> int: ...
    @Digits.setter
    def Digits(self, Value: int) -> None: ...
    @property
    def Radix(self) -> int: ...
    @Radix.setter
    def Radix(self, Value: int) -> None: ...
    @property
    def DecimalPlaces(self) -> int: ...
    @DecimalPlaces.setter
    def DecimalPlaces(self, Value: int) -> None: ...
    @property
    def Amplify(self) -> bool: ...
    @Amplify.setter
    def Amplify(self, Value: bool) -> None: ...
    @property
    def AllowTextInput(self) -> bool: ...
    @AllowTextInput.setter
    def AllowTextInput(self, Value: bool) -> None: ...
    @property
    def AllowRadixDrag(self) -> bool: ...
    @AllowRadixDrag.setter
    def AllowRadixDrag(self, Value: bool) -> None: ...
    @property
    def Prefix(self) -> str: ...
    @Prefix.setter
    def Prefix(self, Value: str) -> None: ...
    @property
    def Suffix(self) -> str: ...
    @Suffix.setter
    def Suffix(self, Value: str) -> None: ...
    @property
    def DigitAlign(self) -> GH_DigitAlign: ...
    @DigitAlign.setter
    def DigitAlign(self, Value: GH_DigitAlign) -> None: ...
    @property
    def DigitScroller(self) -> GH_DigitScrollerBase: ...
    @property
    def Presets(self) -> GH_NumberPresets: ...
    def add_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def remove_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...


class GH_NumberPresets:
    def __init__(self): ...
    @property
    def Count(self) -> int: ...
    def PresetValue(self, index: int) -> Decimal: ...
    def PresetName(self, index: int) -> str: ...
    def PresetDescription(self, index: int) -> str: ...
    @overload
    def AddPreset(self, name: str, value: float) -> None: ...
    @overload
    def AddPreset(self, name: str, value: float, description: str) -> None: ...
    @overload
    def AddPreset(self, name: str, value: Decimal) -> None: ...
    @overload
    def AddPreset(self, name: str, value: Decimal, description: str) -> None: ...
    @overload
    def PopulateMenu(self, menu: ToolStrip, current: Decimal, clickDelegate: EventHandler) -> None: ...
    @overload
    def PopulateMenu(self, menu: ToolStrip, current: Decimal, format: str, clickDelegate: EventHandler) -> None: ...


class GH_SettingsServerBrowser:
    def __init__(self): ...
    @property
    def Server(self) -> GH_SettingsServer: ...
    @Server.setter
    def Server(self, Value: GH_SettingsServer) -> None: ...


class GH_Slider(GH_TextInputBaseControl):
    def __init__(self): ...
    @property
    def ControlEdgeColour(self) -> Color: ...
    @ControlEdgeColour.setter
    def ControlEdgeColour(self, Value: Color) -> None: ...
    @property
    def ControlShadowColour(self) -> Color: ...
    @ControlShadowColour.setter
    def ControlShadowColour(self, Value: Color) -> None: ...
    @property
    def GripTopColour(self) -> Color: ...
    @GripTopColour.setter
    def GripTopColour(self, Value: Color) -> None: ...
    @property
    def GripBottomColour(self) -> Color: ...
    @GripBottomColour.setter
    def GripBottomColour(self, Value: Color) -> None: ...
    @property
    def GripEdgeColour(self) -> Color: ...
    @GripEdgeColour.setter
    def GripEdgeColour(self, Value: Color) -> None: ...
    @property
    def TextColour(self) -> Color: ...
    @TextColour.setter
    def TextColour(self, Value: Color) -> None: ...
    @property
    def RailFullColour(self) -> Color: ...
    @RailFullColour.setter
    def RailFullColour(self, Value: Color) -> None: ...
    @property
    def RailEmptyColour(self) -> Color: ...
    @RailEmptyColour.setter
    def RailEmptyColour(self, Value: Color) -> None: ...
    @property
    def RailDarkColour(self) -> Color: ...
    @RailDarkColour.setter
    def RailDarkColour(self, Value: Color) -> None: ...
    @property
    def RailBrightColour(self) -> Color: ...
    @RailBrightColour.setter
    def RailBrightColour(self, Value: Color) -> None: ...
    @property
    def FormatMask(self) -> str: ...
    @FormatMask.setter
    def FormatMask(self, Value: str) -> None: ...
    @property
    def RailDisplay(self) -> GH_SliderRailDisplay: ...
    @RailDisplay.setter
    def RailDisplay(self, Value: GH_SliderRailDisplay) -> None: ...
    @property
    def GripDisplay(self) -> GH_SliderGripDisplay: ...
    @GripDisplay.setter
    def GripDisplay(self, Value: GH_SliderGripDisplay) -> None: ...
    @property
    def TickDisplay(self) -> GH_SliderTickDisplay: ...
    @TickDisplay.setter
    def TickDisplay(self, Value: GH_SliderTickDisplay) -> None: ...
    @property
    def DrawControlBorder(self) -> bool: ...
    @DrawControlBorder.setter
    def DrawControlBorder(self, Value: bool) -> None: ...
    @property
    def DrawControlShadows(self) -> bool: ...
    @DrawControlShadows.setter
    def DrawControlShadows(self, Value: bool) -> None: ...
    @property
    def TickCount(self) -> int: ...
    @TickCount.setter
    def TickCount(self, Value: int) -> None: ...
    @property
    def TickFrequency(self) -> int: ...
    @TickFrequency.setter
    def TickFrequency(self, Value: int) -> None: ...
    @property
    def ShadowSize(self) -> Padding: ...
    @ShadowSize.setter
    def ShadowSize(self, Value: Padding) -> None: ...
    @property
    def InternalSlider(self) -> GH_SliderBase: ...
    @property
    def Type(self) -> GH_SliderAccuracy: ...
    @Type.setter
    def Type(self, Value: GH_SliderAccuracy) -> None: ...
    @property
    def DecimalPlaces(self) -> int: ...
    @DecimalPlaces.setter
    def DecimalPlaces(self, Value: int) -> None: ...
    @property
    def Minimum(self) -> Decimal: ...
    @Minimum.setter
    def Minimum(self, Value: Decimal) -> None: ...
    @property
    def Maximum(self) -> Decimal: ...
    @Maximum.setter
    def Maximum(self, Value: Decimal) -> None: ...
    @property
    def Value(self) -> Decimal: ...
    @Value.setter
    def Value(self, Value: Decimal) -> None: ...
    def add_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def remove_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...


class GH_UndoServerBrowser:
    def __init__(self): ...
    @property
    def Canvas(self) -> GH_Canvas: ...
    @Canvas.setter
    def Canvas(self, Value: GH_Canvas) -> None: ...


class GH_ValueListEditor:
    def __init__(self): ...
    def AssignValues(self, values: List[GH_ValueListItem]) -> None: ...
    def RetrieveValues(self) -> List: ...
    @property
    def Changed(self) -> bool: ...


class GH_ToolstripItemKeyHandlerResult:
    Ignored = 0
    CloseMenu = 1
    MaintainMenu = 2


class IGH_ToolstripItemKeyHandler:
    def RespondToEnter(self) -> GH_ToolstripItemKeyHandlerResult: ...
    def RespondToEscape(self) -> GH_ToolstripItemKeyHandlerResult: ...


class GH_VersionHistoryRelease:
    def __init__(self): ...
    def PopulateRelease(self, lines: Iterable[str]) -> None: ...
    def LayoutRelease(self) -> None: ...
    @property
    def Expanded(self) -> bool: ...
    @Expanded.setter
    def Expanded(self, Value: bool) -> None: ...


class GH_VoronoiWarningForm:
    def __init__(self): ...


class GH_FadePhase:
    Hidden = 0
    Hiding = 1
    Shown = 2
    Showing = 3


class GH_FadeAnimation:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, threshold: Single): ...
    @overload
    def __init__(self, threshold: Single, duration: int): ...
    @property
    def Threshold(self) -> Single: ...
    @Threshold.setter
    def Threshold(self, Value: Single) -> None: ...
    @property
    def Duration(self) -> int: ...
    @Duration.setter
    def Duration(self, Value: int) -> None: ...
    @property
    def Phase(self) -> GH_FadePhase: ...
    @property
    def IsFinished(self) -> bool: ...
    @property
    def TriggerUpdate(self) -> bool: ...
    @TriggerUpdate.setter
    def TriggerUpdate(self, Value: bool) -> None: ...
    @property
    def FadeAlpha(self) -> int: ...
    @property
    def FadeFactor(self) -> float: ...
    @overload
    def Evaluate(self, canvas: GH_Canvas) -> None: ...
    @overload
    def Evaluate(self, canvas: GH_Canvas, value: Single) -> None: ...
    @overload
    def Evaluate(self, canvas: GH_Canvas, scheduleRedraw: bool) -> None: ...
    @overload
    def Evaluate(self, canvas: GH_Canvas, value: Single, scheduleRedraw: bool) -> None: ...


class GH_Interpolation:
    #None = 0
    NearestNeighbour = 1
    Linear = 2
    EaseIn = 3
    EaseOut = 4
    EaseInAndOut = 5


class GH_AnimationPhase:
    Before = 0
    During = 1
    After = 2


class GH_Animator:
    @overload
    def IntegerAnimator(A: int, B: int) -> GH_Animator: ...
    @overload
    def IntegerAnimator(A: int, B: int, duration: int) -> GH_Animator: ...
    @overload
    def IntegerAnimator(A: int, B: int, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    @overload
    def SingleAnimator(A: Single, B: Single) -> GH_Animator: ...
    @overload
    def SingleAnimator(A: Single, B: Single, duration: int) -> GH_Animator: ...
    @overload
    def SingleAnimator(A: Single, B: Single, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    @overload
    def DoubleAnimator(A: float, B: float) -> GH_Animator: ...
    @overload
    def DoubleAnimator(A: float, B: float, duration: int) -> GH_Animator: ...
    @overload
    def DoubleAnimator(A: float, B: float, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    @overload
    def DecimalAnimator(A: Decimal, B: Decimal) -> GH_Animator: ...
    @overload
    def DecimalAnimator(A: Decimal, B: Decimal, duration: int) -> GH_Animator: ...
    @overload
    def DecimalAnimator(A: Decimal, B: Decimal, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    @overload
    def PointAnimator(A: Point, B: Point) -> GH_Animator: ...
    @overload
    def PointAnimator(A: Point, B: Point, duration: int) -> GH_Animator: ...
    @overload
    def PointAnimator(A: Point, B: Point, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    @overload
    def PointFAnimator(A: PointF, B: PointF) -> GH_Animator: ...
    @overload
    def PointFAnimator(A: PointF, B: PointF, duration: int) -> GH_Animator: ...
    @overload
    def PointFAnimator(A: PointF, B: PointF, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    @overload
    def RectangleAnimator(A: Rectangle, B: Rectangle) -> GH_Animator: ...
    @overload
    def RectangleAnimator(A: Rectangle, B: Rectangle, duration: int) -> GH_Animator: ...
    @overload
    def RectangleAnimator(A: Rectangle, B: Rectangle, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    @overload
    def RectangleFAnimator(A: RectangleF, B: RectangleF) -> GH_Animator: ...
    @overload
    def RectangleFAnimator(A: RectangleF, B: RectangleF, duration: int) -> GH_Animator: ...
    @overload
    def RectangleFAnimator(A: RectangleF, B: RectangleF, time0: DateTime, time1: DateTime) -> GH_Animator: ...
    def InterpolateDouble(A: float, B: float, factor: float) -> float: ...
    def InterpolateSingle(A: Single, B: Single, factor: float) -> Single: ...
    def InterpolateInteger(A: int, B: int, factor: float) -> int: ...
    def InterpolateDecimal(A: Decimal, B: Decimal, factor: float) -> Decimal: ...
    def InterpolatePoint(A: Point, B: Point, factor: float) -> Point: ...
    def InterpolatePointF(A: PointF, B: PointF, factor: float) -> PointF: ...
    def InterpolateRectangle(A: Rectangle, B: Rectangle, factor: float) -> Rectangle: ...
    def InterpolateRectangleF(A: RectangleF, B: RectangleF, factor: float) -> RectangleF: ...




class GH_AssemblyInfoDialog:
    def __init__(self): ...
    def RegisterProxies(self, proxies: Iterable[IGH_ObjectProxy]) -> None: ...
    @property
    def Assembly(self) -> GH_AssemblyInfo: ...
    @Assembly.setter
    def Assembly(self, AutoPropertyValue: GH_AssemblyInfo) -> None: ...


class GH_ClusterGateWayProperties:
    def __init__(self): ...
    @property
    def CustomName(self) -> str: ...
    @CustomName.setter
    def CustomName(self, Value: str) -> None: ...
    @property
    def CustomNickName(self) -> str: ...
    @CustomNickName.setter
    def CustomNickName(self, Value: str) -> None: ...
    @property
    def CustomDescription(self) -> str: ...
    @CustomDescription.setter
    def CustomDescription(self, Value: str) -> None: ...


class GH_ClusterPropertiesEditor:
    def __init__(self): ...
    @overload
    def LoadCluster(self, cluster: GH_Cluster_OBSOLETE) -> None: ...
    def SaveCluster(self, cluster: GH_Cluster_OBSOLETE) -> None: ...
    @overload
    def LoadCluster(self, cluster: GH_Cluster) -> None: ...
    def WriteToCluster(self, cluster: GH_Cluster) -> None: ...


class GH_BezierSolver:
    def __init__(self): ...
    def PointAt(P0: PointF, P1: PointF, P2: PointF, P3: PointF, t: Single) -> Tuple[PointF, PointF, PointF, PointF, PointF]: ...
    def TangentAt(P0: PointF, P1: PointF, P2: PointF, P3: PointF, t: Single) -> Tuple[SizeF, PointF, PointF, PointF, PointF]: ...
    def AngleAt(P0: PointF, P1: PointF, P2: PointF, P3: PointF, t: Single) -> Tuple[Single, PointF, PointF, PointF, PointF]: ...


class GH_DocumentMdiItem(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def Document(self) -> GH_Document: ...
    @Document.setter
    def Document(self, Value: GH_Document) -> None: ...
    @property
    def DesiredHeight(self) -> int: ...
    @property
    def DesiredWidth(self) -> int: ...
    @property
    def CloseArea(self) -> Rectangle: ...
    @property
    def ClusterArea(self) -> Rectangle: ...


class GH_DocumentPreviewSettings:
    def __init__(self): ...
    def add_ColoursChanged(self, obj: ColoursChangedEventHandler) -> None: ...
    def remove_ColoursChanged(self, obj: ColoursChangedEventHandler) -> None: ...
    @property
    def NormalColour(self) -> Color: ...
    @NormalColour.setter
    def NormalColour(self, Value: Color) -> None: ...
    @property
    def SelectedColour(self) -> Color: ...
    @SelectedColour.setter
    def SelectedColour(self, Value: Color) -> None: ...
    def LoadPresets(self) -> None: ...
    def SavePresets(self) -> None: ...


class GH_PreviewSettingsChangedEventArgs:
    def __init__(self, colNormal: Color, colSelected: Color): ...
    @property
    def NormalColour(self) -> Color: ...
    @property
    def SelectedColour(self) -> Color: ...


class GH_FontMappingDialog:
    def __init__(self): ...
    @property
    def lblFont(self) -> Label: ...
    @lblFont.setter
    def lblFont(self, WithEventsValue: Label) -> None: ...
    @property
    def lnkSubstitution(self) -> LinkLabel: ...
    @lnkSubstitution.setter
    def lnkSubstitution(self, WithEventsValue: LinkLabel) -> None: ...
    @property
    def OriginalFont(self) -> str: ...
    @OriginalFont.setter
    def OriginalFont(self, Value: str) -> None: ...
    @property
    def Substitution(self) -> str: ...
    @Substitution.setter
    def Substitution(self, Value: str) -> None: ...


class GH_SeparatorDisplay:
    #None = 0
    Etched = 1
    EtchedFading = 2
    Dashed = 3


class GH_HorizontalSeparator(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def DisplayMode(self) -> GH_SeparatorDisplay: ...
    @DisplayMode.setter
    def DisplayMode(self, Value: GH_SeparatorDisplay) -> None: ...


class GH_VerticalSeparator(GH_DoubleBufferedPanel):
    def __init__(self): ...


class GH_IconLabel:
    def __init__(self): ...
    @property
    def LabelIcon(self) -> Bitmap: ...
    @LabelIcon.setter
    def LabelIcon(self, Value: Bitmap) -> None: ...


class GH_IconPicker:
    def __init__(self): ...
    @property
    def Icon(self) -> Bitmap: ...
    @Icon.setter
    def Icon(self, Value: Bitmap) -> None: ...
    @property
    def IconChanged(self) -> bool: ...


class GH_IconVariations:
    def CreateIconVariationTexts() -> List: ...
    def CreateIconVariations(icon: Bitmap) -> List: ...
    def _IconBlackNewTopOverlay(icon: Bitmap) -> Bitmap: ...
    def _IconBlackNewBottomOverlay(icon: Bitmap) -> Bitmap: ...
    def _IconWhiteBoxBackground(icon: Bitmap) -> Bitmap: ...
    def _IconWhiteGridBackground(icon: Bitmap) -> Bitmap: ...
    def _IconWhiteAdditionLL(icon: Bitmap) -> Bitmap: ...
    def _IconWhiteAdditionLR(icon: Bitmap) -> Bitmap: ...
    def _IconWhiteAdditionTL(icon: Bitmap) -> Bitmap: ...
    def _IconWhiteAdditionTR(icon: Bitmap) -> Bitmap: ...
    def _IconBlackAdditionLL(icon: Bitmap) -> Bitmap: ...
    def _IconBlackAdditionLR(icon: Bitmap) -> Bitmap: ...
    def _IconBlackAdditionTL(icon: Bitmap) -> Bitmap: ...
    def _IconBlackAdditionTR(icon: Bitmap) -> Bitmap: ...
    def _IconGreyScale0(icon: Bitmap) -> Bitmap: ...
    def _IconGreyScale1(icon: Bitmap) -> Bitmap: ...
    def _IconGreyScale2(icon: Bitmap) -> Bitmap: ...
    def _IconGreyScale3(icon: Bitmap) -> Bitmap: ...
    def _IconSatScale0(icon: Bitmap) -> Bitmap: ...
    def _IconSatScale1(icon: Bitmap) -> Bitmap: ...
    def _IconSatScale2(icon: Bitmap) -> Bitmap: ...
    def _IconSatScale3(icon: Bitmap) -> Bitmap: ...
    def _IconDropShadow0(icon: Bitmap) -> Bitmap: ...
    def _IconDropShadow1(icon: Bitmap) -> Bitmap: ...
    def _IconDropShadow2(icon: Bitmap) -> Bitmap: ...
    def _IconDropShadow3(icon: Bitmap) -> Bitmap: ...
    def _TintCustomColour(icon: Bitmap, tint: Color) -> Bitmap: ...


class GH_Constraint:
    #None = 0
    Vertical = 1
    Horizontal = 2


class GH_DragInfo:
    def __init__(self, drag_point: Point, initial_shape: Rectangle): ...
    @property
    def Region(self) -> Rectangle: ...
    @Region.setter
    def Region(self, Value: Rectangle) -> None: ...
    @property
    def Constraint(self) -> GH_Constraint: ...
    @Constraint.setter
    def Constraint(self, Value: GH_Constraint) -> None: ...
    @property
    def Box_Start(self) -> Rectangle: ...
    @property
    def Box_Drag(self) -> Rectangle: ...
    @property
    def Point_Start(self) -> Point: ...
    @property
    def Point_Drag(self) -> Point: ...
    def Drag(self, new_point: Point) -> None: ...


class GH_FindObjectDialog:
    def __init__(self): ...
    @property
    def Canvas(self) -> GH_Canvas: ...
    @Canvas.setter
    def Canvas(self, Value: GH_Canvas) -> None: ...
    @property
    def SelectedHit(self) -> int: ...
    @SelectedHit.setter
    def SelectedHit(self, Value: int) -> None: ...


class GH_FormShepard:
    def __init__(self, nOwner: Form): ...
    def RegisterForm(self, dialog: Form) -> None: ...
    def UnregisterForm(self, dialog: Form) -> None: ...
    @property
    def Sheep(self) -> Iterable[Form]: ...


class GH_GDI_Util:
    def FilletBoxOutline(boxes: Iterable[Rectangle], radius: int) -> GraphicsPath: ...
    def BoxUnion(rectangles: Iterable[Rectangle]) -> List: ...
    def SimplifyBoxes(boxes: Iterable[Rectangle]) -> Set(Rectangle): ...
    @overload
    def FilletPolyline(corners: Set(Point), radius: int) -> GraphicsPath: ...
    @overload
    def FilletPolyline(corners: Set(PointF), radius: Single) -> GraphicsPath: ...
    def FilletRectangle(box: Rectangle, radius: int) -> GraphicsPath: ...
    @overload
    def Freeform_Blob(content: Iterable[RectangleF], padding: int, accuracy: float) -> GraphicsPath: ...
    @overload
    def Freeform_Blob(content: Iterable[RectangleF], padding: int, accuracy: float, solver: FieldSolver, section: float) -> GraphicsPath: ...


class GH_GradientMenuItem:
    def __init__(self): ...
    @property
    def Gradient(self) -> GH_Gradient: ...
    @Gradient.setter
    def Gradient(self, Value: GH_Gradient) -> None: ...
    @property
    def Index(self) -> int: ...
    @Index.setter
    def Index(self, Value: int) -> None: ...
    @property
    def DeleteRequested(self) -> bool: ...
    @DeleteRequested.setter
    def DeleteRequested(self, Value: bool) -> None: ...


class GH_HiResExportForm:
    def __init__(self): ...
    def StorePersistentSettings(self) -> None: ...
    @property
    def ZoomFactor(self) -> Single: ...
    @property
    def FilePath(self) -> str: ...
    @property
    def CanvasColor(self) -> Color: ...


class GH_IconTable:
    @property
    def Count() -> int: ...
    def Icon(index: int) -> Bitmap: ...
    def RegisterIcon(icon: Bitmap) -> int: ...
    def To32BppPArgb(img: Image) -> Bitmap: ...
    def To32BppArgb(img: Image) -> Bitmap: ...
    def ResizeImage(img: Image, size: Size, mode: InterpolationMode, format: PixelFormat) -> Bitmap: ...


class GH_KernelAssemblyCopyLocalWarning:
    def __init__(self): ...


class GH_LexerComboEditor:
    def __init__(self): ...
    @property
    def Lexers(self) -> List: ...
    @Lexers.setter
    def Lexers(self, Value: List) -> None: ...


class GH_LexerMaskEditor:
    def __init__(self): ...


class GH_LoadingError:
    def __init__(self): ...
    @property
    def ErrorTitle(self) -> str: ...
    @ErrorTitle.setter
    def ErrorTitle(self, Value: str) -> None: ...
    @property
    def ErrorMessage(self) -> str: ...
    @ErrorMessage.setter
    def ErrorMessage(self, Value: str) -> None: ...
    @property
    def Folded(self) -> bool: ...
    @Folded.setter
    def Folded(self, Value: bool) -> None: ...


class GH_LoadingExceptionBrowser:
    def __init__(self): ...
    def LoadErrors(self, errors: List) -> None: ...


class GH_MaterialPreview:
    def __init__(self): ...
    @property
    def Colour(self) -> Color: ...
    @Colour.setter
    def Colour(self, Value: Color) -> None: ...
    @property
    def Selected(self) -> bool: ...
    @Selected.setter
    def Selected(self, Value: bool) -> None: ...
    def Image(self) -> Bitmap: ...
    def Thumbnail(self, size: int) -> Bitmap: ...


class GH_MaterialPreviewControl:
    def __init__(self): ...
    def add_SelectedChanged(self, obj: SelectedChangedEventHandler) -> None: ...
    def remove_SelectedChanged(self, obj: SelectedChangedEventHandler) -> None: ...
    def add_ColourChanged(self, obj: ColourChangedEventHandler) -> None: ...
    def remove_ColourChanged(self, obj: ColourChangedEventHandler) -> None: ...
    @property
    def SelectOnClick(self) -> bool: ...
    @SelectOnClick.setter
    def SelectOnClick(self, Value: bool) -> None: ...
    @property
    def Selected(self) -> bool: ...
    @Selected.setter
    def Selected(self, Value: bool) -> None: ...
    @property
    def Colour(self) -> Color: ...
    @Colour.setter
    def Colour(self, Value: Color) -> None: ...
    def add_MaterialImagePostPaint(self, obj: MaterialImagePostPaintEventHandler) -> None: ...
    def remove_MaterialImagePostPaint(self, obj: MaterialImagePostPaintEventHandler) -> None: ...


class GH_MenuStrip:
    def __init__(self): ...
    @property
    def ClickThrough(self) -> bool: ...
    @ClickThrough.setter
    def ClickThrough(self, Value: bool) -> None: ...


class GH_MeshingParameterDialog:
    def __init__(self): ...
    @property
    def MeshingParameters(self) -> GH_MeshingParametersFrontEnd: ...
    @MeshingParameters.setter
    def MeshingParameters(self, WithEventsValue: GH_MeshingParametersFrontEnd) -> None: ...


class GH_PageCurl:
    def __init__(self, anchor: Point, tip: Point): ...
    def RenderTopology(self, g: Graphics) -> None: ...
    @property
    def CurlTip(self) -> PointF: ...
    @property
    def CurlEdge(self) -> GraphicsPath: ...
    @property
    def CurlPath(self) -> GraphicsPath: ...
    @property
    def CurlBrush(self) -> Brush: ...
    @property
    def CurlShadowPath(self) -> GraphicsPath: ...
    @property
    def CurlShadowBrush(self) -> Brush: ...
    @property
    def BackgroundPath(self) -> GraphicsPath: ...
    @property
    def BackgroundShadowPath(self) -> GraphicsPath: ...
    @property
    def BackgroundShadowBrush(self) -> Brush: ...
    @property
    def CurlInterior(self) -> GraphicsPath: ...


class GH_PreviewPreset:
    def __init__(self): ...
    def add_SelectedChanged(self, obj: SelectedChangedEventHandler) -> None: ...
    def remove_SelectedChanged(self, obj: SelectedChangedEventHandler) -> None: ...
    @property
    def Colour(self) -> Color: ...
    @Colour.setter
    def Colour(self, Value: Color) -> None: ...
    @property
    def Selected(self) -> bool: ...
    @Selected.setter
    def Selected(self, Value: bool) -> None: ...


class GH_MDSliderDialog:
    def __init__(self): ...
    def LoadSettings(self, owner: GH_MultiDimensionalSlider) -> None: ...
    def SaveSettings(self, owner: GH_MultiDimensionalSlider) -> None: ...


class GH_TrackerFrame:
    def __init__(self, position: Point): ...


class GH_MouseTracker:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, initialPosition: Point): ...
    @overload
    def __init__(self, initialPosition: Point, tag: Object): ...
    @property
    def FrameCount(self) -> int: ...
    @property
    def Frame(self, index: int) -> GH_TrackerFrame: ...
    @property
    def OldestFrame(self) -> GH_TrackerFrame: ...
    @property
    def NewestFrame(self) -> GH_TrackerFrame: ...
    @property
    def Duration(self) -> TimeSpan: ...
    @property
    def MaximumDuration(self) -> TimeSpan: ...
    @MaximumDuration.setter
    def MaximumDuration(self, Value: TimeSpan) -> None: ...
    @property
    def MaximumFrameCount(self) -> int: ...
    @MaximumFrameCount.setter
    def MaximumFrameCount(self, Value: int) -> None: ...
    @property
    def TemporalAccuracy(self) -> TimeSpan: ...
    @TemporalAccuracy.setter
    def TemporalAccuracy(self, Value: TimeSpan) -> None: ...
    def ToString(self) -> str: ...
    @overload
    def Record(self, position: Point) -> None: ...
    @overload
    def Record(self, position: Point, tag: Object) -> None: ...
    @overload
    def DropFrames(self, timeLimit: DateTime) -> None: ...
    @overload
    def DropFrames(self, deviation: float) -> None: ...
    @overload
    def DropFrames(self, deviation: float, anchor: Point) -> None: ...
    @overload
    def Deviation(self) -> float: ...
    @overload
    def Deviation(self, t0: DateTime, t1: DateTime) -> float: ...
    def LastFrameWithinDeviation(self, deviation: float) -> int: ...


class GH_MultiDocSave:
    def __init__(self): ...
    def AddDocument(self, doc: GH_Document) -> None: ...


class GH_MultiSaveDocumentEntry:
    def __init__(self): ...
    @property
    def Document(self) -> GH_Document: ...
    @Document.setter
    def Document(self, Value: GH_Document) -> None: ...
    @property
    def IsSaved(self) -> bool: ...
    def add_DocumentSaved(self, obj: DocumentSavedEventHandler) -> None: ...
    def remove_DocumentSaved(self, obj: DocumentSavedEventHandler) -> None: ...


class GH_PingMessageWindow:
    def __init__(self): ...
    @property
    def Expire(self) -> DateTime: ...
    @Expire.setter
    def Expire(self, Value: DateTime) -> None: ...
    @property
    def Message(self) -> str: ...
    @Message.setter
    def Message(self, Value: str) -> None: ...


class GH_ScribblePropertiesDialog:
    def __init__(self): ...
    def SetUserFont(self, f: Font) -> None: ...
    def GetUserFont(self) -> Font: ...


class GH_VerticalScrollBar(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def TargetHeight(self) -> int: ...
    @TargetHeight.setter
    def TargetHeight(self, Value: int) -> None: ...
    @property
    def ScreenHeight(self) -> int: ...
    @ScreenHeight.setter
    def ScreenHeight(self, Value: int) -> None: ...
    @property
    def TargetRatio(self) -> float: ...
    @TargetRatio.setter
    def TargetRatio(self, Value: float) -> None: ...
    @property
    def ImpliedVerticalOffset(self) -> int: ...
    @ImpliedVerticalOffset.setter
    def ImpliedVerticalOffset(self, Value: int) -> None: ...
    @property
    def GripRegion(self) -> Rectangle: ...
    @property
    def Grip(self) -> Rectangle: ...
    def add_ScrollRatioChanged(self, obj: ScrollRatioChangedEventHandler) -> None: ...
    def remove_ScrollRatioChanged(self, obj: ScrollRatioChangedEventHandler) -> None: ...


class GH_RhAttributesEditor:
    def __init__(self): ...
    def SetDefaultAttributes(self) -> None: ...
    def GetAttributes(self) -> ObjectAttributes: ...


class GH_CreateStateDialog:
    def __init__(self): ...
    def AddAllDocumentObjects(self, def: GH_Document) -> None: ...
    @property
    def StateList(self) -> List: ...


class GH_DocumentEditor:
    def __init__(self): ...
    def ScriptAccess_NewDocument(self) -> bool: ...
    @overload
    def ScriptAccess_OpenDocument(self) -> bool: ...
    @overload
    def ScriptAccess_OpenDocument(self, filename: str) -> bool: ...
    def ScriptAccess_SaveDocument(self) -> bool: ...
    @overload
    def ScriptAccess_SaveDocumentAs(self) -> bool: ...
    @overload
    def ScriptAccess_SaveDocumentAs(self, path: str) -> bool: ...
    def ScriptAccess_CloseDocument(self) -> bool: ...
    def ScriptAccess_CloseAllDocuments(self) -> bool: ...
    def SetStatusBarEvent(self, event: GH_RuntimeMessage) -> None: ...
    def ClearStatusBar(self) -> None: ...
    def FixCanvasToolbarState(self) -> None: ...
    def ScriptAccess_IsDocument(self) -> bool: ...
    def ScriptAccess_IsDocumentModified(self) -> bool: ...
    @property
    def FormShepard(self) -> GH_FormShepard: ...
    def CloseForReal(self) -> None: ...
    def FadeOut(self) -> None: ...
    def FadeIn(self) -> None: ...
    def EnableUI(self) -> None: ...
    def DisableUI(self) -> None: ...
    def add_AggregateShortcutMenuItems(obj: AggregateShortcutMenuItemsEventHandler) -> None: ...
    def remove_AggregateShortcutMenuItems(obj: AggregateShortcutMenuItemsEventHandler) -> None: ...
    def add_EditorFoldStateChanged(self, obj: EditorFoldStateChangedEventHandler) -> None: ...
    def remove_EditorFoldStateChanged(self, obj: EditorFoldStateChangedEventHandler) -> None: ...
    def CollapseForm(self) -> None: ...
    def ExpandForm(self) -> None: ...
    def ToggleForm(self) -> None: ...
    @property
    def Collapsed(self) -> bool: ...


class GH_MenuShortcutEventArgs:
    def AppendItem(self, item: ToolStripMenuItem) -> None: ...
    @property
    def Owner(self) -> GH_DocumentEditor: ...
    @property
    def MainMenu(self) -> MenuStrip: ...


class GH_ImageSamplerSettingsDialog:
    def __init__(self): ...
    @property
    def Sampler(self) -> GH_ImageSampler: ...
    @Sampler.setter
    def Sampler(self, Value: GH_ImageSampler) -> None: ...
    def ApplySettings(self) -> None: ...
    def RevertSettings(self) -> None: ...


class GH_NickNameTextBox:
    def __init__(self): ...
    def add_NickNameChanged(self, obj: NickNameChangedEventHandler) -> None: ...
    def remove_NickNameChanged(self, obj: NickNameChangedEventHandler) -> None: ...
    def add_IconModeChanged(self, obj: IconModeChangedEventHandler) -> None: ...
    def remove_IconModeChanged(self, obj: IconModeChangedEventHandler) -> None: ...
    def add_NickNameChangeAccepted(self, obj: NickNameChangeAcceptedEventHandler) -> None: ...
    def remove_NickNameChangeAccepted(self, obj: NickNameChangeAcceptedEventHandler) -> None: ...
    def add_NickNameChangeCancelled(self, obj: NickNameChangeCancelledEventHandler) -> None: ...
    def remove_NickNameChangeCancelled(self, obj: NickNameChangeCancelledEventHandler) -> None: ...
    @property
    def OldNickName(self) -> str: ...
    @OldNickName.setter
    def OldNickName(self, Value: str) -> None: ...
    @property
    def OldIconMode(self) -> GH_IconDisplayMode: ...
    @OldIconMode.setter
    def OldIconMode(self, Value: GH_IconDisplayMode) -> None: ...
    @property
    def NewNickName(self) -> str: ...
    @property
    def NewIconMode(self) -> GH_IconDisplayMode: ...


class GH_SourceCodeBlock:
    def __init__(self, i0: int, i1: int, b_readonly: bool): ...
    def Grow(self, line_index: int) -> None: ...
    @property
    def Start(self) -> int: ...
    @property
    def End(self) -> int: ...
    @property
    def LineCount(self) -> int: ...
    @property
    def Readonly(self) -> bool: ...


class GH_SourceCodeLine:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, n_text: str): ...
    @overload
    def __init__(self, n_text: str, b_readonly: bool): ...


class GH_SourceCodeLines:
    def __init__(self): ...
    @overload
    def Add(self, text: str, readonly: bool) -> None: ...
    @property
    def Blocks(self) -> List: ...
    def FindNthBlock(self, N: int, b_include_readonly: bool, b_include_editable: bool) -> GH_SourceCodeBlock: ...
    def StringSplit(delim: str, stream: str) -> List: ...
    def GetLines(self, block: GH_SourceCodeBlock) -> List: ...


class GH_SourceCodeEditor:
    def __init__(self): ...
    @property
    def ManagedID(self) -> Guid: ...
    def CreateManagedEditor(id: Guid) -> GH_SourceCodeEditor: ...
    def DestroyManagedEditor(id: Guid) -> bool: ...
    def GetManagedEditor(id: Guid) -> GH_SourceCodeEditor: ...
    def IsManagedEditor(id: Guid) -> bool: ...
    def RegisterDefaultAssemblies(self) -> None: ...
    def RegisterDefaultSystemNameSpaces(self) -> None: ...
    def RegisterDefaultGrasshopperNameSpaces(self) -> None: ...
    def RegisterDefaultRhinoCommonNameSpaces(self) -> None: ...
    def CollapseAll(self, line_index: int) -> None: ...
    def Clear(self) -> None: ...
    @overload
    def AppendLine(self, line: GH_SourceCodeLine) -> None: ...
    @overload
    def AppendLine(self, line: str, readonly: bool) -> None: ...
    @overload
    def AppendLines(self, lines: Iterable[GH_SourceCodeLine]) -> None: ...
    @overload
    def AppendLines(self, block: str, readonly: bool) -> None: ...
    @property
    def CustomPanel(self) -> Panel: ...
    @property
    def SC_Lines(self) -> GH_SourceCodeLines: ...


class GH_GDI_PolyArc:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, other: GH_GDI_PolyArc): ...
    def StartNewPath(self) -> None: ...
    @overload
    def AppendLine(self, Ax: float, Ay: float, Bx: float, By: float) -> None: ...
    @overload
    def AppendLine(self, A: Point3d, B: Point3d) -> None: ...
    @overload
    def AppendArc(self, Ax: float, Ay: float, Bx: float, By: float, Tx: float, Ty: float) -> None: ...
    @overload
    def AppendArc(self, A: Point3d, B: Point3d, Ta: Vector3d) -> None: ...
    @overload
    def AppendArc3Pt(self, Ax: float, Ay: float, Bx: float, By: float, Cx: float, Cy: float) -> None: ...
    @overload
    def AppendArc3Pt(self, A: Point3d, B: Point3d, C: Point3d) -> None: ...
    @overload
    def AppendArc(self, Arc: Arc) -> None: ...
    def ToPath(self) -> GraphicsPath: ...


class GH_ObjectExceptionDialog:
    def __init__(self): ...


class GH_StateObjectFrontEnd:
    def __init__(self): ...
    def SetupObject(self, obj: IGH_DocumentObject) -> None: ...
    @property
    def Target(self) -> IGH_DocumentObject: ...
    @property
    def Selected(self) -> bool: ...
    @property
    def Include(self) -> bool: ...
    @Include.setter
    def Include(self, Value: bool) -> None: ...


class GH_NumericScrollerValueEditor:
    def __init__(self): ...
    @property
    def tblLayout(self) -> TableLayoutPanel: ...
    @tblLayout.setter
    def tblLayout(self, WithEventsValue: TableLayoutPanel) -> None: ...
    def SetupValues(self, lower: Decimal, upper: Decimal, value: Decimal, decimals: int) -> None: ...
    @property
    def LowerLimit(self) -> Decimal: ...
    @property
    def UpperLimit(self) -> Decimal: ...
    @property
    def Value(self) -> Decimal: ...
    @property
    def OriginalLowerLimit(self) -> Decimal: ...
    @property
    def OriginalUpperLimit(self) -> Decimal: ...
    @property
    def OriginalValue(self) -> Decimal: ...
    def add_OnValueChanged(self, obj: OnValueChangedEventHandler) -> None: ...
    def remove_OnValueChanged(self, obj: OnValueChangedEventHandler) -> None: ...
    def add_OnLimitsChanged(self, obj: OnLimitsChangedEventHandler) -> None: ...
    def remove_OnLimitsChanged(self, obj: OnLimitsChangedEventHandler) -> None: ...
    def PrepareForCancel(self) -> None: ...
    def PrepareForCommit(self) -> None: ...


class GH_InfoTextBox:
    def __init__(self): ...
    @property
    def TextBox(self) -> TextBox: ...
    @TextBox.setter
    def TextBox(self, WithEventsValue: TextBox) -> None: ...
    @property
    def DefaultMessage(self) -> str: ...
    @DefaultMessage.setter
    def DefaultMessage(self, Value: str) -> None: ...
    @property
    def Text(self) -> str: ...
    @Text.setter
    def Text(self, Value: str) -> None: ...
    @overload
    def add_TextChanged(self, obj: TextChangedEventHandler) -> None: ...
    @overload
    def remove_TextChanged(self, obj: TextChangedEventHandler) -> None: ...


class GH_InfoTextBoxEventArgs:
    def __init__(self, control: GH_InfoTextBox): ...
    @property
    def Control(self) -> GH_InfoTextBox: ...
    @property
    def TextBox(self) -> TextBox: ...
    @property
    def Text(self) -> str: ...


class GH_ArrowControl:
    def __init__(self): ...


class GH_ASSERT_DIALOG:
    def __init__(self): ...
    @property
    def Message(self) -> str: ...
    @Message.setter
    def Message(self, Value: str) -> None: ...
    @property
    def GUID(self) -> Guid: ...
    @GUID.setter
    def GUID(self, Value: Guid) -> None: ...
    def AddFrame(self, method: str, type: str, file: str, line: str) -> None: ...


class GH_ComponentGuidConflictDialog:
    def __init__(self): ...
    def SetupDialog(self, cLoaded: IGH_ObjectProxy, cConflicted: IGH_ObjectProxy) -> None: ...
    @property
    def LoadedProxy(self) -> IGH_ObjectProxy: ...
    @property
    def ConflictingProxy(self) -> IGH_ObjectProxy: ...
    @property
    def Solution(self) -> GH_GuidConflictSolution: ...


class GH_Toolstrip:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, items: Set(ToolStripItem)): ...
    @property
    def ClickThrough(self) -> bool: ...
    @ClickThrough.setter
    def ClickThrough(self, Value: bool) -> None: ...


class GH_Tooltip:
    def Clear() -> None: ...
    @property
    def TooltipForm() -> GH_ToolTipForm: ...
    def Show(owner: Control) -> None: ...
    def Adjust() -> None: ...
    def Layout() -> None: ...
    def TooltipDetailedInformation() -> str: ...
    @property
    def Tag() -> Object: ...
    @Tag.setter
    def Tag(Value: Object) -> None: ...
    def IsTag(test: Object) -> bool: ...
    def IsOwner(test: Control) -> bool: ...
    def AssignTooltipFields(title: str, text: str, description: str, icon: Image, diagram: Image) -> None: ...


class GH_TooltipDisplayEventArgs:
    @property
    def Control(self) -> Control: ...
    @property
    def Point(self) -> Point: ...
    @property
    def Icon(self) -> Bitmap: ...
    @Icon.setter
    def Icon(self, Value: Bitmap) -> None: ...
    @property
    def Diagram(self) -> Bitmap: ...
    @Diagram.setter
    def Diagram(self, Value: Bitmap) -> None: ...
    @property
    def Title(self) -> str: ...
    @Title.setter
    def Title(self, Value: str) -> None: ...
    @property
    def Text(self) -> str: ...
    @Text.setter
    def Text(self, Value: str) -> None: ...
    @property
    def Description(self) -> str: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @property
    def Valid(self) -> bool: ...
    @property
    def Region(self) -> Rectangle: ...
    @Region.setter
    def Region(self, Value: Rectangle) -> None: ...


class GH_TooltipComponent:
    def __init__(self): ...
    def Hide(self) -> None: ...
    @property
    def Enabled(self) -> bool: ...
    @Enabled.setter
    def Enabled(self, Value: bool) -> None: ...
    @property
    def Delay(self) -> int: ...
    @Delay.setter
    def Delay(self, Value: int) -> None: ...
    @property
    def Target(self) -> Control: ...
    @Target.setter
    def Target(self, Value: Control) -> None: ...
    @property
    def Tag(self) -> Object: ...
    @Tag.setter
    def Tag(self, Value: Object) -> None: ...
    def IsTag(self, object: Object) -> bool: ...
    def add_PopulateTooltip(self, obj: PopulateTooltipEventHandler) -> None: ...
    def remove_PopulateTooltip(self, obj: PopulateTooltipEventHandler) -> None: ...


class GH_ToolTipForm:
    def __init__(self): ...
    @TT_Icon.setter
    def TT_Icon(self, Value: Image) -> None: ...
    @TT_Diagram.setter
    def TT_Diagram(self, Value: Image) -> None: ...
    @property
    def TT_Palette(self) -> GH_TooltipPalette: ...
    @TT_Palette.setter
    def TT_Palette(self, Value: GH_TooltipPalette) -> None: ...
    @property
    def TT_Title(self) -> str: ...
    @TT_Title.setter
    def TT_Title(self, Value: str) -> None: ...
    @property
    def TT_Text(self) -> str: ...
    @TT_Text.setter
    def TT_Text(self, Value: str) -> None: ...
    @property
    def TT_Description(self) -> str: ...
    @TT_Description.setter
    def TT_Description(self, Value: str) -> None: ...
    @property
    def DefaultTooltipWidth() -> int: ...
    @property
    def DefaultBlockWidth() -> int: ...


class IGH_Tooltip:
    @Icon.setter
    def Icon(self, Value: Image) -> None: ...
    @Diagram.setter
    def Diagram(self, Value: Image) -> None: ...
    @property
    def Title(self) -> str: ...
    @Title.setter
    def Title(self, Value: str) -> None: ...
    @property
    def Text(self) -> str: ...
    @Text.setter
    def Text(self, Value: str) -> None: ...
    @property
    def Description(self) -> str: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @property
    def Palette(self) -> GH_TooltipPalette: ...
    @Palette.setter
    def Palette(self, Value: GH_TooltipPalette) -> None: ...


class GH_TooltipPalette:
    White = 0
    Black = 1
    Grey = 2
    Yellow = 3
    Orange = 4
    Red = 5
    Green = 6
    Blue = 7


class GH_DateTimePicker:
    def __init__(self): ...


class GH_DeveloperSettings:
    def __init__(self): ...


class GH_DoubleBufferedPanel:
    def __init__(self): ...


class GH_NumberSliderPopup:
    def __init__(self): ...
    def Setup(self, owner: GH_NumberSlider) -> None: ...


class GH_ExpressionEditor:
    def __init__(self): ...
    @property
    def PreviewDelegate(self) -> GH_PreviewExpression: ...
    @PreviewDelegate.setter
    def PreviewDelegate(self, Value: GH_PreviewExpression) -> None: ...
    @property
    def Expression(self) -> str: ...
    @Expression.setter
    def Expression(self, Value: str) -> None: ...
    @property
    def Variables(self) -> Dictionary: ...


class GH_FolderPathBrowser:
    def __init__(self): ...
    def add_PathChanged(self, obj: PathChangedEventHandler) -> None: ...
    def remove_PathChanged(self, obj: PathChangedEventHandler) -> None: ...
    @property
    def Path(self) -> str: ...
    @Path.setter
    def Path(self, Value: str) -> None: ...
    @property
    def BrowseText(self) -> str: ...
    @BrowseText.setter
    def BrowseText(self, Value: str) -> None: ...
    @property
    def Filter(self) -> str: ...
    @Filter.setter
    def Filter(self, Value: str) -> None: ...
    @property
    def RequireExisting(self) -> bool: ...
    @RequireExisting.setter
    def RequireExisting(self, Value: bool) -> None: ...
    @property
    def IsFolderBrowser(self) -> bool: ...
    @property
    def IsFileBrowser(self) -> bool: ...
    def IsValidPath(pathString: str) -> bool: ...


class GH_UserObjectDeleteConfirmationDialog:
    def __init__(self): ...
    def SetMessage(self, objectName: str) -> None: ...


class GH_UserObjectProperties:
    def __init__(self): ...
    @property
    def ObjectIcon(self) -> Bitmap: ...
    @ObjectIcon.setter
    def ObjectIcon(self, Value: Bitmap) -> None: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def InstanceDescription(self) -> GH_InstanceDescription: ...


class GH_VariableParameterManager:
    def __init__(self): ...
    def ClearParameters(self) -> None: ...
    @overload
    def AddProxy(self, param: IGH_Param, bVariable: bool, bMutable: bool) -> None: ...
    @overload
    def AddProxy(self, sNickName: str, bVariable: bool, bMutable: bool) -> None: ...
    @property
    def Side(self) -> GH_VarParamSide: ...
    @Side.setter
    def Side(self, Value: GH_VarParamSide) -> None: ...
    @property
    def Component(self) -> IGH_VarParamComponent: ...
    @Component.setter
    def Component(self, Value: IGH_VarParamComponent) -> None: ...
    @property
    def NameConstructor(self) -> IGH_ParamNameConstructor: ...
    @NameConstructor.setter
    def NameConstructor(self, Value: IGH_ParamNameConstructor) -> None: ...
    @property
    def Proxies(self) -> List: ...


class GH_VersionHistoryForm:
    def __init__(self): ...


class GH_GradientEditor:
    def __init__(self): ...
    @property
    def Gradient(self) -> GH_Gradient: ...
    @Gradient.setter
    def Gradient(self, Value: GH_Gradient) -> None: ...


class GH_GraphEditor:
    def __init__(self): ...
    def SetGraph(self, G: GH_GraphContainer) -> None: ...
    @property
    def Graph(self) -> GH_GraphContainer: ...


class GH_GraphicsUtil:
    @property
    def UiScale() -> Single: ...
    def HighlightPen() -> Pen: ...
    def HighlightBrush() -> Brush: ...
    @overload
    def RenderHighlightBox(g: Graphics, box: Rectangle, cornerRadius: int) -> None: ...
    @overload
    def RenderHighlightBox(g: Graphics, box: Rectangle, cornerRadius: int, drawFill: bool, drawEdge: bool) -> None: ...
    @overload
    def RenderHighlightBox(g: Graphics, box: Rectangle, cornerRadius: int, fill: Color, edge: Color) -> None: ...
    def LimitInteger(channel: int) -> Tuple[int]: ...
    def LimitIntegers(r: int, g: int, b: int) -> Tuple[int, int, int]: ...
    @overload
    def ColourARGB(r: int, g: int, b: int) -> Color: ...
    @overload
    def ColourARGB(a: int, r: int, g: int, b: int) -> Color: ...
    @overload
    def ColourARGB(r: float, g: float, b: float) -> Color: ...
    def InvertColour(col: Color) -> Color: ...
    def ForegroundColour(col: Color, contrast: int) -> Color: ...
    @overload
    def OffsetColour(col: Color, shift: int) -> Color: ...
    @overload
    def OffsetColour(col: Color, redShift: int, greenShift: int, blueShift: int) -> Color: ...
    def ScaleColour(col: Color, factor: float) -> Color: ...
    def BlendInteger(t0: float, t1: float, a0: int, a1: int, t: float) -> int: ...
    def FadeColour(t0: float, t1: float, t: float, col: Color) -> Color: ...
    @overload
    def BlendColour(bottom: Color, top: Color) -> Color: ...
    @overload
    def BlendColour(bottom: Color, top: Color, factor: float) -> Color: ...
    def Distance(a: PointF, b: PointF) -> Single: ...
    def DistanceS(a: PointF, b: PointF) -> Single: ...
    def IsPointInEllipse(ellipse: RectangleF, point: PointF) -> bool: ...
    @overload
    def EtchHorizontal(g: Graphics, x0: Single, x1: Single, y: Single, alpha: int) -> None: ...
    @overload
    def EtchHorizontal(g: Graphics, x0: int, x1: int, y: int, alphaLight: int, alphaDark: int) -> None: ...
    def EtchFadingHorizontal(g: Graphics, x0: int, x1: int, y: int, alphaLight: int, alphaDark: int) -> None: ...
    @overload
    def EtchVertical(g: Graphics, x: Single, y0: Single, y1: Single, alpha: int) -> None: ...
    @overload
    def EtchVertical(g: Graphics, x: int, y0: int, y1: int, alpha: int) -> None: ...
    def EtchFadingVertical(g: Graphics, y0: int, y1: int, x: int, alphaLight: int, alphaDark: int) -> None: ...
    @overload
    def Grid(g: Graphics, rec: RectangleF, density: int) -> None: ...
    @overload
    def Grid(g: Graphics, rec: RectangleF, densityX: int, densityY: int) -> None: ...
    @overload
    def Grid(g: Graphics, rec: RectangleF, densityX: int, densityY: int, colorBg: Color, colorWire: Color) -> None: ...
    @overload
    def ShadowHorizontal(g: Graphics, x0: Single, x1: Single, y: Single, size: Single, below: bool, darkness: int) -> None: ...
    @overload
    def ShadowHorizontal(g: Graphics, x0: int, x1: int, y: int, size: int, below: bool, darkness: int) -> None: ...
    @overload
    def ShadowHorizontal(g: Graphics, x0: int, x1: int, y: int, size: int, below: bool, color: Color) -> None: ...
    @overload
    def ShadowVertical(g: Graphics, x: Single, y0: Single, y1: Single, size: Single, right: bool, darkness: int) -> None: ...
    @overload
    def ShadowVertical(g: Graphics, x: int, y0: int, y1: int, size: int, right: bool, darkness: int) -> None: ...
    @overload
    def ShadowVertical(g: Graphics, x: int, y0: int, y1: int, size: int, right: bool, color: Color) -> None: ...
    @overload
    def ShadowRectangle(g: Graphics, rec: Rectangle, size: int, darkness: int) -> None: ...
    @overload
    def ShadowRectangle(g: Graphics, rec: Rectangle, size: int, color: Color) -> None: ...
    @overload
    def DentHorizontal(g: Graphics, box: Rectangle) -> None: ...
    @overload
    def DentHorizontal(g: Graphics, box: Rectangle, alphaEdge: int, alphaFill: int) -> None: ...
    @overload
    def DentVertical(g: Graphics, box: Rectangle) -> None: ...
    @overload
    def DentVertical(g: Graphics, box: Rectangle, alphaEdge: int, alphaFill: int) -> None: ...
    def RenderVerticalString(g: Graphics, text: str, font: Font, colour: Color, rec: RectangleF, format: StringFormat) -> None: ...
    @overload
    def RenderUnscaledIcon(g: Graphics, icon: Image, cx: int, cy: int) -> None: ...
    @overload
    def RenderUnscaledIcon(g: Graphics, icon: Image, cx: int, cy: int, fade: float) -> None: ...
    @overload
    def RenderCenteredIcon(g: Graphics, frame: RectangleF, icon: Image) -> None: ...
    @overload
    def RenderCenteredIcon(g: Graphics, frame: RectangleF, icon: Image, scale: Single) -> None: ...
    def RenderIcon(graphics: Graphics, frame: RectangleF, icon: Image) -> None: ...
    @overload
    def RenderCenteredIcon(g: Graphics, frame: RectangleF, icon: Image, alpha: float) -> None: ...
    def CreateColourIcon(width: int, height: int, colour: Color) -> Bitmap: ...
    @overload
    def RenderColourIcon(g: Graphics, rec: Rectangle, colour: Color) -> None: ...
    @overload
    def RenderColourIcon(g: Graphics, rec: Rectangle, colour: Color, scale: Single) -> None: ...
    @overload
    def RenderObjectOverlay(graphics: Graphics, obj: IGH_DocumentObject, target: RectangleF) -> None: ...
    @overload
    def RenderObjectOverlay(graphics: Graphics, obj: IGH_ObjectProxy, target: RectangleF) -> None: ...
    @overload
    def TransparencyMatrix(alpha: int) -> ColorMatrix: ...
    @overload
    def TransparencyMatrix(fade: float) -> ColorMatrix: ...
    @overload
    def RenderFadedImage(graphics: Graphics, image: Image, destination: Rectangle, alpha: int) -> None: ...
    @overload
    def RenderFadedImage(graphics: Graphics, image: Image, destination: Rectangle, fade: float) -> None: ...
    def RenderWarningIcon(graphics: Graphics, center: PointF, radius: Single, alpha: int) -> None: ...
    def RenderRoundBar(graphics: Graphics, rec: RectangleF, colour: Color) -> None: ...
    def RenderCenteredText(g: Graphics, text: str, font: Font, color: Color, center: PointF) -> None: ...
    def RenderTag(g: Graphics, tag: str, font: Font, backColor: Color, foreColor: Color, frame: RectangleF, alignH: StringAlignment, alignV: StringAlignment) -> None: ...
    @overload
    def RenderBalloonTag(g: Graphics, text: str, tip: PointF, container: RectangleF) -> None: ...
    @overload
    def RenderBalloonTag(g: Graphics, text: str, font: Font, tip: PointF, container: RectangleF) -> None: ...
    @overload
    def RenderBalloonTag(g: Graphics, text: str, font: Font, backColor: Color, foreColor: Color, tip: PointF, container: RectangleF) -> None: ...
    @overload
    def RenderBalloonTag(g: Graphics, text: str, font: Font, backColor: Color, foreColor: Color, tip: PointF, upright: bool) -> None: ...
    def BoxClosestArcPoint(pt: PointF, box: RectangleF) -> PointF: ...
    @overload
    def BoxClosestPoint(pt: PointF, box: RectangleF) -> PointF: ...
    @overload
    def BoxClosestPoint(pt: Point, box: Rectangle) -> Point: ...
    @overload
    def BoxFurthestPoint(pt: PointF, box: RectangleF) -> PointF: ...
    @overload
    def BoxFurthestPoint(pt: Point, box: Rectangle) -> Point: ...
    def BoxViewCone(pt: PointF, box: RectangleF) -> GraphicsPath: ...
    @overload
    def SolveArc(p0: PointF, p1: PointF, dir: SizeF, box: RectangleF, angle: Single, sweep: Single) -> Tuple[bool, RectangleF, Single, Single]: ...
    @overload
    def SolveArc(p0: Point3d, p1: Point3d, dir: Vector3d, box: RectangleF, angle: Single, sweep: Single) -> Tuple[bool, RectangleF, Single, Single]: ...
    @overload
    def SolveArc(p0X: float, p0Y: float, p1X: float, p1Y: float, dx: float, dy: float, box: RectangleF, angle: Single, sweep: Single) -> Tuple[bool, RectangleF, Single, Single]: ...
    @overload
    def AppendArc(p0: PointF, p1: PointF, dir: SizeF, path: GraphicsPath) -> None: ...
    @overload
    def AppendArc(p0: Point3d, p1: Point3d, dir: Vector3d, path: GraphicsPath) -> None: ...


class GH_Interval2DPicker:
    def __init__(self): ...
    def add_IntervalChanged(self, obj: IntervalChangedEventHandler) -> None: ...
    def remove_IntervalChanged(self, obj: IntervalChangedEventHandler) -> None: ...
    def OnIntervalChanged(self) -> None: ...
    @property
    def Interval(self) -> UVInterval: ...
    @Interval.setter
    def Interval(self, Value: UVInterval) -> None: ...


class GH_Label(GH_DoubleBufferedPanel):
    def __init__(self): ...
    @property
    def Text(self) -> str: ...
    @Text.setter
    def Text(self, AutoPropertyValue: str) -> None: ...
    @property
    def TextAlign(self) -> ContentAlignment: ...
    @TextAlign.setter
    def TextAlign(self, AutoPropertyValue: ContentAlignment) -> None: ...
    @property
    def Image(self) -> Image: ...
    @Image.setter
    def Image(self, AutoPropertyValue: Image) -> None: ...
    @property
    def ImageAlign(self) -> ContentAlignment: ...
    @ImageAlign.setter
    def ImageAlign(self, AutoPropertyValue: ContentAlignment) -> None: ...


class GH_ListScroller:
    def __init__(self): ...
    def add_SelectedIndexChanged(self, obj: SelectedIndexChangedEventHandler) -> None: ...
    def remove_SelectedIndexChanged(self, obj: SelectedIndexChangedEventHandler) -> None: ...
    def OnSelectedItemChanged(self, bIntermediate: bool) -> None: ...
    def AddItem(self, sItem: str) -> None: ...
    @property
    def DebugItems(self) -> bool: ...
    @DebugItems.setter
    def DebugItems(self, Value: bool) -> None: ...
    @property
    def SelectedIndex(self) -> int: ...
    @SelectedIndex.setter
    def SelectedIndex(self, Value: int) -> None: ...
    @property
    def WrapItems(self) -> bool: ...
    @WrapItems.setter
    def WrapItems(self, Value: bool) -> None: ...
    @property
    def ItemHeight(self) -> int: ...
    @ItemHeight.setter
    def ItemHeight(self, Value: int) -> None: ...


class GH_ListScrollerChangedEventArgs:
    def __init__(self, nItem: str, nIndex: int, bIntermediate: bool): ...
    @property
    def Item(self) -> str: ...
    @property
    def Index(self) -> int: ...
    @property
    def Intermediate(self) -> bool: ...


class GH_NumericTextBox:
    def __init__(self): ...
    def add_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def remove_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def add_OnScrollStart(self, obj: OnScrollStartEventHandler) -> None: ...
    def remove_OnScrollStart(self, obj: OnScrollStartEventHandler) -> None: ...
    def add_OnScrollEnd(self, obj: OnScrollEndEventHandler) -> None: ...
    def remove_OnScrollEnd(self, obj: OnScrollEndEventHandler) -> None: ...
    def OnValueChanged(self, newvalue: float, oldvalue: float, final: bool) -> None: ...
    @property
    def Suffix(self) -> str: ...
    @Suffix.setter
    def Suffix(self, Value: str) -> None: ...
    @property
    def Prefix(self) -> str: ...
    @Prefix.setter
    def Prefix(self, Value: str) -> None: ...
    @property
    def Value(self) -> float: ...
    @Value.setter
    def Value(self, val: float) -> None: ...
    @property
    def LowerLimit(self) -> float: ...
    @LowerLimit.setter
    def LowerLimit(self, val: float) -> None: ...
    @property
    def UpperLimit(self) -> float: ...
    @UpperLimit.setter
    def UpperLimit(self, val: float) -> None: ...
    def Set(self, l_limit: float, u_limit: float, v_value: float) -> None: ...
    @property
    def Decimals(self) -> int: ...
    @Decimals.setter
    def Decimals(self, val: int) -> None: ...
    @property
    def ScrollWidth(self) -> int: ...
    @ScrollWidth.setter
    def ScrollWidth(self, val: int) -> None: ...
    @property
    def ScrollIncrement(self) -> float: ...
    @ScrollIncrement.setter
    def ScrollIncrement(self, val: float) -> None: ...
    @property
    def ScrollDamping(self) -> int: ...
    @ScrollDamping.setter
    def ScrollDamping(self, Value: int) -> None: ...
    @property
    def ScrollMethod(self) -> GH_Scroll_Method: ...
    @ScrollMethod.setter
    def ScrollMethod(self, val: GH_Scroll_Method) -> None: ...
    @property
    def InScrollMode(self) -> bool: ...
    @property
    def ScrollingHasBegun(self) -> bool: ...
    @property
    def PreScrollValue(self) -> float: ...
    @property
    def ScrollingUpwards(self) -> bool: ...
    def RefreshScrollPanel(self) -> None: ...
    @property
    def ScrollMouseRelation(self) -> GH_ScrollMouseRelation: ...
    @ScrollMouseRelation.setter
    def ScrollMouseRelation(self, Value: GH_ScrollMouseRelation) -> None: ...
    def PrepareForCommit(self) -> None: ...
    def PrepareForCancel(self) -> None: ...
    def SetDefault(self, num: float) -> None: ...


class GH_PointCurveParamEditor:
    def __init__(self): ...
    def LoadPoint(self, pt: GH_Point) -> None: ...
    def SetDataToPoint(self) -> None: ...


class GH_ProgressBar:
    def __init__(self): ...
    @property
    def Message(self) -> str: ...
    @Message.setter
    def Message(self, Value: str) -> None: ...
    @property
    def Progress(self) -> float: ...
    @Progress.setter
    def Progress(self, Value: float) -> None: ...
    @property
    def CurrentStep(self) -> int: ...
    @property
    def DrawPercentage(self) -> bool: ...
    @DrawPercentage.setter
    def DrawPercentage(self, Value: bool) -> None: ...
    @property
    def DrawSteps(self) -> bool: ...
    @DrawSteps.setter
    def DrawSteps(self, Value: bool) -> None: ...
    def SetMaxSteps(self, S: int) -> None: ...
    @overload
    def SetStep(self, N: int) -> None: ...
    @overload
    def SetStep(self, N: int, sText: str) -> None: ...


class GH_VariableParamProxy:
    def __init__(self): ...
    @property
    def BlankID(self) -> bool: ...
    @property
    def ID(self) -> Guid: ...
    @ID.setter
    def ID(self, Value: Guid) -> None: ...
    @property
    def NickName(self) -> str: ...
    @NickName.setter
    def NickName(self, Value: str) -> None: ...
    @property
    def Variable(self) -> bool: ...
    @Variable.setter
    def Variable(self, Value: bool) -> None: ...
    @property
    def Mutable(self) -> bool: ...
    @Mutable.setter
    def Mutable(self, Value: bool) -> None: ...
    @property
    def Deleted(self) -> bool: ...
    @Deleted.setter
    def Deleted(self, Value: bool) -> None: ...
    def UpdateUI(self) -> None: ...


class GH_MarkupAttributesDialog:
    def __init__(self): ...
    def add_AttributesChanged(self, obj: AttributesChangedEventHandler) -> None: ...
    def remove_AttributesChanged(self, obj: AttributesChangedEventHandler) -> None: ...
    def add_AttributesAccepted(self, obj: AttributesAcceptedEventHandler) -> None: ...
    def remove_AttributesAccepted(self, obj: AttributesAcceptedEventHandler) -> None: ...
    def add_AttributesDenied(self, obj: AttributesDeniedEventHandler) -> None: ...
    def remove_AttributesDenied(self, obj: AttributesDeniedEventHandler) -> None: ...
    @property
    def OriginalProperties(self) -> GH_MarkupProperties: ...
    @OriginalProperties.setter
    def OriginalProperties(self, AutoPropertyValue: GH_MarkupProperties) -> None: ...
    @property
    def ModifiedProperties(self) -> GH_MarkupProperties: ...
    @ModifiedProperties.setter
    def ModifiedProperties(self, AutoPropertyValue: GH_MarkupProperties) -> None: ...
    def ReadAttributes(self, iAtt: GH_MarkupAttributes) -> None: ...
    def WriteAttributes(self, iAtt: GH_MarkupAttributes) -> None: ...
    def UndoAttributes(self, iAtt: GH_MarkupAttributes) -> None: ...
    @property
    def GripRegion(self) -> Rectangle: ...
    @property
    def WidthRegion(self) -> Rectangle: ...
    @property
    def DashRegion(self) -> Rectangle: ...
    @property
    def ColourRegion(self) -> Rectangle: ...
    @property
    def AcceptRegion(self) -> Rectangle: ...
    @property
    def CancelRegion(self) -> Rectangle: ...


class GH_MenuTextBox:
    def __init__(self, dropDown: ToolStripDropDown, text: str, lockFocus: bool): ...
    def add_TextChanged(self, obj: TextChangedEventHandler) -> None: ...
    def remove_TextChanged(self, obj: TextChangedEventHandler) -> None: ...
    def add_KeyDown(self, obj: KeyDownEventHandler) -> None: ...
    def remove_KeyDown(self, obj: KeyDownEventHandler) -> None: ...
    @property
    def Width(self) -> int: ...
    @Width.setter
    def Width(self, Value: int) -> None: ...
    @property
    def OriginalText(self) -> str: ...
    @OriginalText.setter
    def OriginalText(self, AutoPropertyValue: str) -> None: ...
    @property
    def Text(self) -> str: ...
    @Text.setter
    def Text(self, Value: str) -> None: ...
    @property
    def TextBoxItem(self) -> ToolStripTextBox: ...
    def CloseEntireMenuStructure(self) -> None: ...


class GH_MultilineGooEditor:
    def __init__(self): ...
    @property
    def ParsePaths(self) -> bool: ...
    @ParsePaths.setter
    def ParsePaths(self, Value: bool) -> None: ...
    @property
    def Modified(self) -> bool: ...
    @Modified.setter
    def Modified(self, Value: bool) -> None: ...
    def SetDataList(self, data: Iterable[IGH_Goo]) -> None: ...
    def GetDataList(self, defaultInstance: T) -> List: ...
    def SetDataTree(self, data: IGH_Structure) -> None: ...
    def GetDataTree(self) -> GH_Structure: ...


class GH_PanelEditor:
    def __init__(self): ...


class GH_ParserFunctionViewer:
    def __init__(self): ...


class GH_RemoteSliderControl:
    def __init__(self): ...
    def IsTarget(self, iObject: IGH_DocumentObject) -> bool: ...
    def RegisterTarget(self, iSlider: GH_NumberSlider) -> None: ...
    def UnregisterTarget(self) -> None: ...


class GH_RemoteSwitchControl:
    def __init__(self): ...
    def IsTarget(self, iObject: IGH_DocumentObject) -> bool: ...
    def RegisterTarget(self, iSwitch: GH_BooleanSwitch_Obsolete) -> None: ...
    def UnregisterTarget(self) -> None: ...


class GH_RevisionEditor:
    def __init__(self): ...


class GH_Slider_Obsolete:
    def __init__(self): ...
    @property
    def Min(self) -> float: ...
    @Min.setter
    def Min(self, Value: float) -> None: ...
    @property
    def Max(self) -> float: ...
    @Max.setter
    def Max(self, Value: float) -> None: ...
    @property
    def Value(self) -> float: ...
    @Value.setter
    def Value(self, Value: float) -> None: ...
    @property
    def ValueF(self) -> Single: ...
    @ValueF.setter
    def ValueF(self, Value: Single) -> None: ...
    @property
    def NumericFormat(self) -> str: ...
    @NumericFormat.setter
    def NumericFormat(self, Value: str) -> None: ...
    @property
    def DisplayFormat(self) -> str: ...
    @DisplayFormat.setter
    def DisplayFormat(self, Value: str) -> None: ...
    @property
    def GripBackColor(self) -> Color: ...
    @GripBackColor.setter
    def GripBackColor(self, Value: Color) -> None: ...
    @property
    def GripForeColor(self) -> Color: ...
    @GripForeColor.setter
    def GripForeColor(self, Value: Color) -> None: ...
    @property
    def DrawRail(self) -> bool: ...
    @DrawRail.setter
    def DrawRail(self, Value: bool) -> None: ...
    @property
    def TickFrequency(self) -> int: ...
    @TickFrequency.setter
    def TickFrequency(self, Value: int) -> None: ...
    @property
    def TextInputMode(self) -> GH_SliderInputMode: ...
    @TextInputMode.setter
    def TextInputMode(self, Value: GH_SliderInputMode) -> None: ...
    def add_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def remove_ValueChanged(self, obj: ValueChangedEventHandler) -> None: ...
    def OnValueChanged(self) -> None: ...
    @property
    def IsIntermediate(self) -> bool: ...
    def SendMessage(hWnd: IntPtr, msg: int, wParam: int, lParam: IntPtr) -> IntPtr: ...


class GH_SliderInputMode:
    #None = 0
    OnKeyDown = 1
    OnDoubleClick = 2
    All = 3


class GH_SliderAnimationSetup:
    def __init__(self): ...
    def RegisterAnimator(self, nAnimator: GH_SliderAnimator) -> None: ...
    def RhinoViews(self) -> List: ...
    def FindViewport(self, view: str) -> RhinoViewport: ...
    def CreatePreview(self) -> None: ...


class GH_TextRenderingConstants:
    @property
    def GH_CrispText() -> TextRenderingHint: ...
    @property
    def GH_SmoothText() -> TextRenderingHint: ...
    @property
    def CenterCenter() -> StringFormat: ...
    @property
    def NearCenter() -> StringFormat: ...
    @property
    def FarCenter() -> StringFormat: ...
    def StringFormat(horizontalAlignment: StringAlignment, verticalAlignment: StringAlignment) -> StringFormat: ...


class GH_UndoRecordBrowser:
    def __init__(self): ...
    def LoadUndoRecords(self, server: GH_UndoServer) -> None: ...


class GH_WindowsControlUtil:
    @overload
    def FixTextRenderingDefault(control: Control) -> None: ...
    @overload
    def FixTextRenderingDefault(iControls: ControlCollection) -> None: ...


class IGH_Embeddable:
    def PrepareForCommit(self) -> None: ...
    def PrepareForCancel(self) -> None: ...


class IGH_FileDropTarget:
    def AcceptableFile(self, path: str) -> bool: ...
    def HandleDrop(self, path: str, mouse_pt: PointF) -> bool: ...


class GH_DocumentPropertiesEditor:
    def __init__(self): ...
    def SetDocumentProperties(self, Props: GH_DocumentProperties) -> None: ...


class GH_ParseAssemblyProgressDialog:
    def __init__(self): ...
    def SetMaxSteps(self, Steps: int) -> None: ...
    def SetStep(self, Text: str) -> None: ...


class GH_Splitter:
    def __init__(self): ...
    @property
    def MinSize(self) -> int: ...
    @MinSize.setter
    def MinSize(self, Value: int) -> None: ...
    @property
    def MaxSize(self) -> int: ...
    @MaxSize.setter
    def MaxSize(self, Value: int) -> None: ...
    @property
    def Neighbour(self) -> str: ...
    def FindNeighbour(self) -> None: ...
    def AdjustNeighbour(self) -> None: ...


class IGH_FixedSizeControl:
    def NearestWidth(self, w: int) -> int: ...
    def NearestHeight(self, h: int) -> int: ...


class GH_CursorServer:
    def ReferenceCursors(self, folder: str) -> int: ...
    @property
    def Count(self) -> int: ...
    def IsCursor(self, name: str) -> bool: ...
    def Cursor(self, name: str) -> Cursor: ...
    def AttachCursor(self, control: Control, name: str) -> bool: ...
    def ResetCursor(self, control: Control) -> bool: ...


class GH_MenuShortCutWrapper:
    def GenerateShortcutCommand(keyCode: Keys, menu: ToolStrip) -> bool: ...


class GH_Banner:
    def __init__(self): ...
    def HideBanner(self) -> None: ...
    @property
    def ShowLibraryIcons(self) -> bool: ...
    @ShowLibraryIcons.setter
    def ShowLibraryIcons(self, Value: bool) -> None: ...
    def AddAssemblyInfo(self, info: GH_AssemblyInfo) -> None: ...
    def AddAllAssemblyInfo(self) -> None: ...
    def UpdateLibraryUI(self) -> None: ...


class GH_PersistentDataEditor:
    def __init__(self): ...
    def SetData(self, data: GH_Structure, typeInstance: IGH_Goo) -> None: ...
    def GetData(self) -> GH_Structure: ...


class GH_CanvasMouseEvent:
    @overload
    def __init__(self, vp: GH_Viewport, e_args: MouseEventArgs): ...
    @overload
    def __init__(self, pt_control: Point, pt_canvas: PointF, mButton: MouseButtons, iClicks: int, iDelta: int): ...
    @overload
    def __init__(self): ...
    @property
    def ControlLocation(self) -> Point: ...
    @property
    def CanvasLocation(self) -> PointF: ...
    @property
    def ControlX(self) -> int: ...
    @property
    def ControlY(self) -> int: ...
    @property
    def CanvasX(self) -> Single: ...
    @property
    def CanvasY(self) -> Single: ...
    @property
    def Button(self) -> MouseButtons: ...
    @property
    def Clicks(self) -> int: ...
    @property
    def Delta(self) -> int: ...
    @property
    def WinFormsEventArgs(self) -> MouseEventArgs: ...


class GH_CanvasObjectMouseDownEventArgs:
    def __init__(self, sender: GH_Canvas, object: GH_RelevantObjectData): ...
    @property
    def Canvas(self) -> GH_Canvas: ...
    @property
    def Document(self) -> GH_Document: ...
    @property
    def Object(self) -> GH_RelevantObjectData: ...


class GH_YakDownloadFormEto:
    def __init__(self, items: Iterable[Item]): ...


class FileChangedDelegate:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_AsynchFileData, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_AsynchFileData) -> None: ...


class ColourChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_ColourPickerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_ColourPickerEventArgs) -> None: ...


class ColourChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_ColourSwatchEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_ColourSwatchEventArgs) -> None: ...


class ValuesChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_ControlKnobValueEditor, lower: Decimal, upper: Decimal, value: Decimal, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_ControlKnobValueEditor, lower: Decimal, upper: Decimal, value: Decimal) -> None: ...


class FileLoadClickedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class FileDeleteClickedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class PostPaint:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, graphics: Graphics, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, graphics: Graphics) -> None: ...


class SelectionChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class DataChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class KeyDownEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_MenuCustomControl, e: KeyEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_MenuCustomControl, e: KeyEventArgs) -> None: ...


class MeshingParametersChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_MeshingParametersEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_MeshingParametersEventArgs) -> None: ...


class ValidPasswordEnteredEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class GH_PaintDelegate:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, control: Control, e: PaintEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, control: Control, e: PaintEventArgs) -> None: ...


class UndoRedoChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_RibbonLayoutEditorUndoRedoEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_RibbonLayoutEditorUndoRedoEventArgs) -> None: ...


class ValueChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DigitScrollerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DigitScrollerEventArgs) -> None: ...


class ValueChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_SliderEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_SliderEventArgs) -> None: ...




class ColoursChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_PreviewSettingsChangedEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_PreviewSettingsChangedEventArgs) -> None: ...


class SelectedChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class ColourChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class MaterialImagePostPaintEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, image: Bitmap, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, image: Bitmap) -> None: ...


class SelectedChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class DocumentSavedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: EventArgs) -> None: ...


class ScrollRatioChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_VerticalScrollBar, ratio: float, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_VerticalScrollBar, ratio: float) -> None: ...


class AggregateShortcutMenuItemsEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_MenuShortcutEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_MenuShortcutEventArgs) -> None: ...


class EditorFoldStateChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_DocumentEditor, e: EventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_DocumentEditor, e: EventArgs) -> None: ...


class NickNameChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, new_name: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, new_name: str) -> None: ...


class IconModeChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, new_mode: GH_IconDisplayMode, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, new_mode: GH_IconDisplayMode) -> None: ...


class NickNameChangeAcceptedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_NickNameTextBox, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_NickNameTextBox) -> None: ...


class NickNameChangeCancelledEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_NickNameTextBox, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_NickNameTextBox) -> None: ...


class OnValueChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_NumericScrollerValueEditor, lower: Decimal, upper: Decimal, value: Decimal, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_NumericScrollerValueEditor, lower: Decimal, upper: Decimal, value: Decimal) -> None: ...


class OnLimitsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_NumericScrollerValueEditor, lower: Decimal, upper: Decimal, value: Decimal, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_NumericScrollerValueEditor, lower: Decimal, upper: Decimal, value: Decimal) -> None: ...


class TextChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_InfoTextBoxEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_InfoTextBoxEventArgs) -> None: ...


class PopulateTooltipEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_TooltipDisplayEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_PreviewExpression:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, nExpression: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, nExpression: str) -> None: ...


class PathChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_FolderPathBrowser, nPath: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_FolderPathBrowser, nPath: str) -> None: ...


class IntervalChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_Interval2DPicker, int: UVInterval, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_Interval2DPicker, int: UVInterval) -> None: ...


class SelectedIndexChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_ListScroller, e: GH_ListScrollerChangedEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_ListScroller, e: GH_ListScrollerChangedEventArgs) -> None: ...


class GH_Scroll_Method:
    none = 0
    linear = 1
    exponential = 2


class GH_ValueChangedEventArgs:
    def __init__(self, newval: float, oldval: float, final: bool): ...
    @property
    def NewValue(self) -> float: ...
    @property
    def OldValue(self) -> float: ...
    @property
    def IsFinal(self) -> bool: ...


class ValueChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_NumericTextBox, e: GH_ValueChangedEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_NumericTextBox, e: GH_ValueChangedEventArgs) -> None: ...


class OnScrollStartEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_NumericTextBox, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_NumericTextBox) -> None: ...


class OnScrollEndEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_NumericTextBox, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_NumericTextBox) -> None: ...


class GH_ScrollMouseRelation:
    #None = 0
    Top = 1
    Bottom = 2
    Both = 3


class AttributesChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_MarkupAttributesDialog, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_MarkupAttributesDialog) -> None: ...


class AttributesAcceptedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_MarkupAttributesDialog, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_MarkupAttributesDialog) -> None: ...


class AttributesDeniedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_MarkupAttributesDialog, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_MarkupAttributesDialog) -> None: ...


class TextChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_MenuTextBox, newText: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_MenuTextBox, newText: str) -> None: ...


class KeyDownEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_MenuTextBox, e: KeyEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_MenuTextBox, e: KeyEventArgs) -> None: ...


class ValueChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_Slider_Obsolete, nValue: float, bIntermediate: bool, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_Slider_Obsolete, nValue: float, bIntermediate: bool) -> None: ...


class Item:
    def __init__(self): ...
    @property
    def Name(self) -> str: ...
    @Name.setter
    def Name(self, AutoPropertyValue: str) -> None: ...
    @property
    def Version(self) -> str: ...
    @Version.setter
    def Version(self, value: str) -> None: ...
    @property
    def Id(self) -> Guid: ...
    @Id.setter
    def Id(self, AutoPropertyValue: Guid) -> None: ...
