from typing import Tuple, Set, Iterable, List




class GH_ComponentAttributes:
    def __init__(self, component: IGH_Component): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def ExpireLayout(self) -> None: ...
    def LayoutComponentBox(owner: IGH_Component) -> RectangleF: ...
    def LayoutInputParams(owner: IGH_Component, componentBox: RectangleF) -> None: ...
    def LayoutOutputParams(owner: IGH_Component, componentBox: RectangleF) -> None: ...
    def LayoutBounds(owner: IGH_Component, bounds: RectangleF) -> RectangleF: ...
    def AppendToAttributeTree(self, attributes: List) -> None: ...
    @property
    def ContentBox(self) -> RectangleF: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @property
    def PathName(self) -> str: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    def InvalidateCanvas(self, canvas: GH_Canvas, e: GH_CanvasMouseEvent) -> bool: ...
    def RenderComponentParameters(canvas: GH_Canvas, graphics: Graphics, owner: IGH_Component, style: GH_PaletteStyle) -> None: ...


class GH_FloatingParamAttributes:
    def __init__(self, param: IGH_Param): ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_LinkedParamAttributes:
    def __init__(self, param: IGH_Param, parent: IGH_Attributes): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
