from typing import Tuple, Set, Iterable, List


class GH_TypeHintServer:
    def FindHintByID(hint_id: Guid) -> IGH_TypeHint: ...
    def FindHintByName(hint_name: str) -> IGH_TypeHint: ...


class GH_HintSeparator:
    def __init__(self): ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...
    @property
    def HintID(self) -> Guid: ...
    @property
    def TypeName(self) -> str: ...


class GH_NullHint:
    def __init__(self): ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...
    @property
    def HintID(self) -> Guid: ...
    @property
    def TypeName(self) -> str: ...


class GH_BooleanHint_VB:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_IntegerHint_VB:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_DoubleHint_VB:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_StringHint_VB:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_BooleanHint_CS:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_IntegerHint_CS:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_DoubleHint_CS:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_StringHint_CS:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_DateTimeHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_ColorHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_GuidHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_ComplexHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_Point3dHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_Vector3dHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_PlaneHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_BoxHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_IntervalHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_UVIntervalHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_TransformHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_LineHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_CircleHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_ArcHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_Rectangle3dHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_PolylineHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_CurveHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_SurfaceHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_BrepHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_MeshHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class GH_GeometryBaseHint:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...
