from typing import Tuple, Set, Iterable, List


class Param_Culture:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_LatLonLocation:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def TypeName(self) -> str: ...


class Param_Field:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...


class Param_Matrix:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Group:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Transform:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_SubD:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class GH_ExpressionUndoAction(GH_ObjectUndoAction):
    def __init__(self, obj: IGH_DocumentObject, expression: str): ...
    @property
    def ExpiresSolution(self) -> bool: ...


class IGH_ExpressionParameter:
    @property
    def Expression(self) -> str: ...
    @Expression.setter
    def Expression(self, Value: str) -> None: ...




class Param_MeshParameters:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_FilePath:
    def __init__(self): ...
    @property
    def FileFilter(self) -> str: ...
    @FileFilter.setter
    def FileFilter(self, AutoPropertyValue: str) -> None: ...
    @property
    def AllFilesFilter() -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    @property
    def ExpireOnFileEvent(self) -> bool: ...
    @ExpireOnFileEvent.setter
    def ExpireOnFileEvent(self, AutoPropertyValue: bool) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_Rectangle:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Guid:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class GH_ReceiverAttributes(GH_FloatingParamAttributes):
    def __init__(self, owner: GH_Receiver): ...


class GH_Receiver:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    @property
    def WireAppearance(self) -> GH_WireAppearance: ...
    @WireAppearance.setter
    def WireAppearance(self, Value: GH_WireAppearance) -> None: ...
    @property
    def DrawTag(self) -> bool: ...
    @DrawTag.setter
    def DrawTag(self, Value: bool) -> None: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def InstanceDescription(self) -> str: ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class IGH_TypeHint:
    @property
    def TypeName(self) -> str: ...
    @property
    def HintID(self) -> Guid: ...
    def Cast(self, data: Object) -> Tuple[bool, Object]: ...


class Param_Arc:
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...


class Param_Box:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class GH_ProxyParameterAttributes:
    def __init__(self, owner: GH_ProxyParameter): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def OutputGrip(self) -> PointF: ...


class GH_ProxyParameter:
    def __init__(self, nUUID: Guid): ...
    @property
    def ProxyGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def CreateAttributes(self) -> None: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Point:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    def ClearData(self) -> None: ...
    def RemoveEffects(self) -> None: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...
    def DocumentContextChanged(self, document: GH_Document, context: GH_DocumentContext) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    @property
    def Expression(self) -> str: ...
    @Expression.setter
    def Expression(self, Value: str) -> None: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def Locked(self) -> bool: ...
    @Locked.setter
    def Locked(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...


class Param_Vector:
    def __init__(self): ...
    @property
    def Unitize(self) -> bool: ...
    @Unitize.setter
    def Unitize(self, Value: bool) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def RemoveEffects(self) -> None: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_Boolean:
    def __init__(self): ...
    @property
    def Invert(self) -> bool: ...
    @Invert.setter
    def Invert(self, Value: bool) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def RemoveEffects(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_Brep:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Circle:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Colour:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Curve:
    def __init__(self): ...
    @property
    def TypeName(self) -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def RemoveEffects(self) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_Number:
    def __init__(self): ...
    @property
    def AngleParameter(self) -> bool: ...
    @AngleParameter.setter
    def AngleParameter(self, Value: bool) -> None: ...
    @property
    def UseDegrees(self) -> bool: ...
    @UseDegrees.setter
    def UseDegrees(self, Value: bool) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_Geometry:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def GeometryParameterID() -> Guid: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Integer:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def AddNamedValue(self, name: str, value: int) -> None: ...
    def ClearNamedValues(self) -> None: ...
    @property
    def HasNamedValues(self) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Line:
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def LineThroughBox(P: Line, B: BoundingBox) -> Line: ...


class Param_Mesh:
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...


class Param_MeshFace:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_GenericObject:
    def __init__(self): ...
    def GenericDataCleanup(data: GH_Structure) -> None: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @property
    def AngleParameter(self) -> bool: ...
    @AngleParameter.setter
    def AngleParameter(self, AutoPropertyValue: bool) -> None: ...
    @property
    def UseDegrees(self) -> bool: ...
    @UseDegrees.setter
    def UseDegrees(self, AutoPropertyValue: bool) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_OGLShader:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Interval2D_OBSOLETE:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Interval2D:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Interval:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Plane:
    def __init__(self): ...
    def RegisterRemoteIDs(self, id_list: GH_GuidTable) -> None: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def PlaneThroughBox(P: Plane, B: BoundingBox) -> PlaneSurface: ...


class Param_ScriptVariable(Param_GenericObject):
    def __init__(self): ...
    @property
    def ShowHints(self) -> bool: ...
    @ShowHints.setter
    def ShowHints(self, Value: bool) -> None: ...
    @property
    def TypeHint(self) -> IGH_TypeHint: ...
    @TypeHint.setter
    def TypeHint(self, Value: IGH_TypeHint) -> None: ...
    @property
    def Hints(self) -> List: ...
    @Hints.setter
    def Hints(self, Value: List) -> None: ...
    @property
    def AllowTreeAccess(self) -> bool: ...
    @AllowTreeAccess.setter
    def AllowTreeAccess(self, Value: bool) -> None: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_String:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Surface:
    def __init__(self): ...
    def RemoveEffects(self) -> None: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def Hidden(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class Param_Time:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_StructurePath:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class Param_Complex:
    def __init__(self): ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ComponentGuid(self) -> Guid: ...


class GH_WireAppearance:
    never = 0
    selected = 1
    always = 2


class GH_GeometryProxy:
    def __init__(self, nValue: IGH_GeometricGoo): ...
    @property
    def IsParsable(self) -> bool: ...
