from typing import Tuple, Set, Iterable, List


class IGH_SketchElement:
    @property
    def Icon_24x24(self) -> Image: ...
    @property
    def BoundingBox(self) -> RectangleF: ...
    @property
    def GraphicsPath(self) -> GraphicsPath: ...
    @overload
    def IsPickPoint(self, pt: PointF) -> bool: ...
    @overload
    def IsPickPoint(self, box: RectangleF, bCrossingBox: GH_PickBox) -> bool: ...


class GH_SketchElement:
    @property
    def GraphicsPath(self) -> GraphicsPath: ...
    @property
    def BoundingBox(self) -> RectangleF: ...
    @overload
    def IsPickPoint(self, pt: PointF) -> bool: ...
    @overload
    def IsPickPoint(self, box: RectangleF, bCrossingBox: GH_PickBox) -> bool: ...
    @property
    def Name(self) -> str: ...
    @Name.setter
    def Name(self, Value: str) -> None: ...
    @property
    def Description(self) -> str: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @property
    def Icon_24x24(self) -> Image: ...
    @property
    def NickName(self) -> str: ...
    @NickName.setter
    def NickName(self, Value: str) -> None: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Category(self) -> str: ...
    @Category.setter
    def Category(self, Value: str) -> None: ...
    @property
    def SubCategory(self) -> str: ...
    @SubCategory.setter
    def SubCategory(self, Value: str) -> None: ...
    @property
    def HasCategory(self) -> bool: ...
    @property
    def HasSubCategory(self) -> bool: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def InstanceGuid(self) -> Guid: ...
    @overload
    def NewInstanceGuid(self) -> None: ...
    @overload
    def NewInstanceGuid(self, UUID: Guid) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...


class GH_SketchFreehandStroke:
    def __init__(self): ...


class GH_SketchLine:
    def __init__(self): ...


class GH_SketchBox:
    def __init__(self): ...


class GH_SketchEllipse:
    def __init__(self): ...


class GH_SketchCloud:
    def __init__(self): ...
