from typing import Tuple, Set, Iterable, List


class EtoExtensions:
    @overload
    def ToEto(control: Control) -> Control: ...
    @overload
    def ToEto(control: Form) -> Window: ...
    def ToWin32Window(window: Window) -> IWin32Window: ...
    @overload
    def ToSD(rectangle: Rectangle) -> Rectangle: ...
    @overload
    def ToSD(size: Size) -> Size: ...
    @overload
    def ToSD(point: Point) -> Point: ...
    @overload
    def ToEto(sdcolor: Color) -> Color: ...
    @overload
    def ToSD(color: Color) -> Color: ...
    @overload
    def ToEto(bitmap: Bitmap) -> Bitmap: ...
    @overload
    def ToSD(font: Font) -> Font: ...
    @overload
    def ToEto(font: Font) -> Font: ...
    @overload
    def ToEto(point: Point) -> Point: ...


class CentralSettings:
    @CreateSolutionUndoRecord.setter
    def CreateSolutionUndoRecord(Value: bool) -> None: ...
    @property
    def PruderyLevel() -> GH_PruderyFilter: ...
    @PruderyLevel.setter
    def PruderyLevel(Value: GH_PruderyFilter) -> None: ...
    def IsLoadProtected(pluginName: str) -> bool: ...
    def SetLoadProtected(pluginName: str, loadProtect: bool) -> None: ...
    def GetLoadMechanism(pluginName: str) -> GH_LoadingDemand: ...
    def SetLoadMechanism(pluginName: str, mechanism: GH_LoadingDemand) -> None: ...
    def add_AuthorNameChanged(obj: AuthorNameChangedEventHandler) -> None: ...
    def remove_AuthorNameChanged(obj: AuthorNameChangedEventHandler) -> None: ...
    def add_AuthorCompanyChanged(obj: AuthorCompanyChangedEventHandler) -> None: ...
    def remove_AuthorCompanyChanged(obj: AuthorCompanyChangedEventHandler) -> None: ...
    def add_AuthorCopyrightChanged(obj: AuthorCopyrightChangedEventHandler) -> None: ...
    def remove_AuthorCopyrightChanged(obj: AuthorCopyrightChangedEventHandler) -> None: ...
    def add_AuthorAddressChanged(obj: AuthorAddressChangedEventHandler) -> None: ...
    def remove_AuthorAddressChanged(obj: AuthorAddressChangedEventHandler) -> None: ...
    def add_AuthorWebsiteChanged(obj: AuthorWebsiteChangedEventHandler) -> None: ...
    def remove_AuthorWebsiteChanged(obj: AuthorWebsiteChangedEventHandler) -> None: ...
    def add_AuthorEMailChanged(obj: AuthorEMailChangedEventHandler) -> None: ...
    def remove_AuthorEMailChanged(obj: AuthorEMailChangedEventHandler) -> None: ...
    def add_AuthorPhoneChanged(obj: AuthorPhoneChangedEventHandler) -> None: ...
    def remove_AuthorPhoneChanged(obj: AuthorPhoneChangedEventHandler) -> None: ...
    def add_FormattingChanged(obj: FormattingChangedEventHandler) -> None: ...
    def remove_FormattingChanged(obj: FormattingChangedEventHandler) -> None: ...
    def add_RibbonVisibleChanged(obj: RibbonVisibleChangedEventHandler) -> None: ...
    def remove_RibbonVisibleChanged(obj: RibbonVisibleChangedEventHandler) -> None: ...
    def add_RibbonAllIconsChanged(obj: RibbonAllIconsChangedEventHandler) -> None: ...
    def remove_RibbonAllIconsChanged(obj: RibbonAllIconsChangedEventHandler) -> None: ...
    def add_RibbonSeparatorsChanged(obj: RibbonSeparatorsChangedEventHandler) -> None: ...
    def remove_RibbonSeparatorsChanged(obj: RibbonSeparatorsChangedEventHandler) -> None: ...
    def add_RibbonDrawTabIconsChanged(obj: RibbonDrawTabIconsChangedEventHandler) -> None: ...
    def remove_RibbonDrawTabIconsChanged(obj: RibbonDrawTabIconsChangedEventHandler) -> None: ...
    def add_UiScaleChanged(obj: UiScaleChangedEventHandler) -> None: ...
    def remove_UiScaleChanged(obj: UiScaleChangedEventHandler) -> None: ...
    def add_TemplateFileChanged(obj: TemplateFileChangedEventHandler) -> None: ...
    def remove_TemplateFileChanged(obj: TemplateFileChangedEventHandler) -> None: ...
    def add_CanvasFancyWiresChanged(obj: CanvasFancyWiresChangedEventHandler) -> None: ...
    def remove_CanvasFancyWiresChanged(obj: CanvasFancyWiresChangedEventHandler) -> None: ...
    def add_CanvasObjectIconsChanged(obj: CanvasObjectIconsChangedEventHandler) -> None: ...
    def remove_CanvasObjectIconsChanged(obj: CanvasObjectIconsChangedEventHandler) -> None: ...
    def add_CanvasRadialMenuChanged(obj: CanvasRadialMenuChangedEventHandler) -> None: ...
    def remove_CanvasRadialMenuChanged(obj: CanvasRadialMenuChangedEventHandler) -> None: ...
    def add_CanvasFullNamesChanged(obj: CanvasFullNamesChangedEventHandler) -> None: ...
    def remove_CanvasFullNamesChanged(obj: CanvasFullNamesChangedEventHandler) -> None: ...
    def add_CanvasObsoleteTagsChanged(obj: CanvasObsoleteTagsChangedEventHandler) -> None: ...
    def remove_CanvasObsoleteTagsChanged(obj: CanvasObsoleteTagsChangedEventHandler) -> None: ...
    def add_CanvasZuiZoomLevelChanged(obj: CanvasZuiZoomLevelChangedEventHandler) -> None: ...
    def remove_CanvasZuiZoomLevelChanged(obj: CanvasZuiZoomLevelChangedEventHandler) -> None: ...
    def add_TooltipWiggleRadiusChanged(obj: TooltipWiggleRadiusChangedEventHandler) -> None: ...
    def remove_TooltipWiggleRadiusChanged(obj: TooltipWiggleRadiusChangedEventHandler) -> None: ...
    def add_PreviewMeshEdgesChanged(obj: PreviewMeshEdgesChangedEventHandler) -> None: ...
    def remove_PreviewMeshEdgesChanged(obj: PreviewMeshEdgesChangedEventHandler) -> None: ...
    def add_PreviewPlaneRadiusChanged(obj: PreviewPlaneRadiusChangedEventHandler) -> None: ...
    def remove_PreviewPlaneRadiusChanged(obj: PreviewPlaneRadiusChangedEventHandler) -> None: ...
    def add_PreviewPointStyleChanged(obj: PreviewPointStyleChangedEventHandler) -> None: ...
    def remove_PreviewPointStyleChanged(obj: PreviewPointStyleChangedEventHandler) -> None: ...
    def add_PreviewBumpZBufferChanged(obj: PreviewBumpZBufferChangedEventHandler) -> None: ...
    def remove_PreviewBumpZBufferChanged(obj: PreviewBumpZBufferChangedEventHandler) -> None: ...
    def add_PreviewGumballsChanged(obj: PreviewGumballsChangedEventHandler) -> None: ...
    def remove_PreviewGumballsChanged(obj: PreviewGumballsChangedEventHandler) -> None: ...
    def add_ComponentCascadeMenusChanged(obj: ComponentCascadeMenusChangedEventHandler) -> None: ...
    def remove_ComponentCascadeMenusChanged(obj: ComponentCascadeMenusChangedEventHandler) -> None: ...
    def add_CreateSolutionUndoRecordChanged(obj: CreateSolutionUndoRecordChangedEventHandler) -> None: ...
    def remove_CreateSolutionUndoRecordChanged(obj: CreateSolutionUndoRecordChangedEventHandler) -> None: ...
    def add_PruderyLevelChanged(obj: PruderyLevelChangedEventHandler) -> None: ...
    def remove_PruderyLevelChanged(obj: PruderyLevelChangedEventHandler) -> None: ...
    def add_LoadProtectionChanged(obj: LoadProtectionChangedEventHandler) -> None: ...
    def remove_LoadProtectionChanged(obj: LoadProtectionChangedEventHandler) -> None: ...
    def add_LoadMechanismChanged(obj: LoadMechanismChangedEventHandler) -> None: ...
    def remove_LoadMechanismChanged(obj: LoadMechanismChangedEventHandler) -> None: ...
    @property
    def InvalidBakeAsk() -> bool: ...
    @InvalidBakeAsk.setter
    def InvalidBakeAsk(AutoPropertyValue: bool) -> None: ...
    @property
    def InvalidBakeAllow() -> bool: ...
    @InvalidBakeAllow.setter
    def InvalidBakeAllow(AutoPropertyValue: bool) -> None: ...
    def UserOkayWithBakingInvalidObject(objectType: str) -> bool: ...
    @property
    def AuthorName() -> str: ...
    @AuthorName.setter
    def AuthorName(Value: str) -> None: ...
    @property
    def AuthorCompany() -> str: ...
    @AuthorCompany.setter
    def AuthorCompany(Value: str) -> None: ...
    @property
    def AuthorCopyright() -> str: ...
    @AuthorCopyright.setter
    def AuthorCopyright(Value: str) -> None: ...
    @property
    def AuthorCopyrightFormatted() -> str: ...
    @property
    def AuthorAddress() -> str: ...
    @AuthorAddress.setter
    def AuthorAddress(Value: str) -> None: ...
    @property
    def AuthorWebsite() -> str: ...
    @AuthorWebsite.setter
    def AuthorWebsite(Value: str) -> None: ...
    @property
    def AuthorEMail() -> str: ...
    @AuthorEMail.setter
    def AuthorEMail(Value: str) -> None: ...
    @property
    def AuthorPhone() -> str: ...
    @AuthorPhone.setter
    def AuthorPhone(Value: str) -> None: ...
    @property
    def AuthorDetails() -> IGH_Author: ...
    @property
    def FormatENotationUpperLimit() -> int: ...
    @FormatENotationUpperLimit.setter
    def FormatENotationUpperLimit(Value: int) -> None: ...
    @property
    def FormatENotationLowerLimit() -> int: ...
    @FormatENotationLowerLimit.setter
    def FormatENotationLowerLimit(Value: int) -> None: ...
    @property
    def FormatENotationUpperThreshold() -> float: ...
    @property
    def FormatENotationLowerThreshold() -> float: ...
    @property
    def FormatENotationDigits() -> int: ...
    @FormatENotationDigits.setter
    def FormatENotationDigits(Value: int) -> None: ...
    @property
    def FormatDecimalDigits() -> int: ...
    @FormatDecimalDigits.setter
    def FormatDecimalDigits(Value: int) -> None: ...
    @property
    def FormatMultiplesOfOne() -> bool: ...
    @FormatMultiplesOfOne.setter
    def FormatMultiplesOfOne(Value: bool) -> None: ...
    @property
    def FormatMultiplesOfPi() -> bool: ...
    @FormatMultiplesOfPi.setter
    def FormatMultiplesOfPi(Value: bool) -> None: ...
    @property
    def RibbonVisible() -> bool: ...
    @RibbonVisible.setter
    def RibbonVisible(Value: bool) -> None: ...
    @property
    def RibbonShowObscure() -> bool: ...
    @RibbonShowObscure.setter
    def RibbonShowObscure(Value: bool) -> None: ...
    @property
    def RibbonSeparators() -> bool: ...
    @RibbonSeparators.setter
    def RibbonSeparators(Value: bool) -> None: ...
    @property
    def RibbonDrawTabIcons() -> bool: ...
    @RibbonDrawTabIcons.setter
    def RibbonDrawTabIcons(Value: bool) -> None: ...
    @property
    def TemplateFile() -> str: ...
    @TemplateFile.setter
    def TemplateFile(Value: str) -> None: ...
    @property
    def IsTemplateFile() -> bool: ...
    @property
    def ShowTutorials() -> bool: ...
    @ShowTutorials.setter
    def ShowTutorials(Value: bool) -> None: ...
    @property
    def CanvasFancyWires() -> bool: ...
    @CanvasFancyWires.setter
    def CanvasFancyWires(Value: bool) -> None: ...
    @property
    def CanvasObjectIcons() -> bool: ...
    @CanvasObjectIcons.setter
    def CanvasObjectIcons(Value: bool) -> None: ...
    @property
    def CanvasRadialMenu() -> bool: ...
    @CanvasRadialMenu.setter
    def CanvasRadialMenu(Value: bool) -> None: ...
    @property
    def CanvasFullNames() -> bool: ...
    @CanvasFullNames.setter
    def CanvasFullNames(Value: bool) -> None: ...
    @property
    def CanvasObsoleteTags() -> bool: ...
    @CanvasObsoleteTags.setter
    def CanvasObsoleteTags(Value: bool) -> None: ...
    @property
    def CanvasZuiZoomLevel() -> Single: ...
    @CanvasZuiZoomLevel.setter
    def CanvasZuiZoomLevel(Value: Single) -> None: ...
    @property
    def CanvasSpaceIsRadialMenu() -> bool: ...
    @CanvasSpaceIsRadialMenu.setter
    def CanvasSpaceIsRadialMenu(Value: bool) -> None: ...
    @property
    def CanvasMaxSearchResults() -> int: ...
    @CanvasMaxSearchResults.setter
    def CanvasMaxSearchResults(Value: int) -> None: ...
    @property
    def CanvasSpaceSearchRadialMessage() -> int: ...
    @CanvasSpaceSearchRadialMessage.setter
    def CanvasSpaceSearchRadialMessage(Value: int) -> None: ...
    @property
    def TooltipWiggleRadius() -> int: ...
    @TooltipWiggleRadius.setter
    def TooltipWiggleRadius(Value: int) -> None: ...
    @property
    def PreviewMeshEdges() -> bool: ...
    @PreviewMeshEdges.setter
    def PreviewMeshEdges(Value: bool) -> None: ...
    @property
    def PreviewPlaneRadius() -> float: ...
    @PreviewPlaneRadius.setter
    def PreviewPlaneRadius(Value: float) -> None: ...
    @property
    def PreviewPointStyle() -> PointStyle: ...
    @PreviewPointStyle.setter
    def PreviewPointStyle(Value: PointStyle) -> None: ...
    @property
    def PreviewPointRadius() -> int: ...
    @property
    def PreviewBumpZBuffer() -> bool: ...
    @PreviewBumpZBuffer.setter
    def PreviewBumpZBuffer(Value: bool) -> None: ...
    @property
    def PreviewGumballs() -> bool: ...
    @PreviewGumballs.setter
    def PreviewGumballs(Value: bool) -> None: ...
    @property
    def PreviewSelectionThickening() -> int: ...
    @PreviewSelectionThickening.setter
    def PreviewSelectionThickening(Value: int) -> None: ...
    @property
    def ComponentCascadeMenus() -> bool: ...
    @ComponentCascadeMenus.setter
    def ComponentCascadeMenus(Value: bool) -> None: ...
    @property
    def CreateSolutionUndoRecord() -> bool: ...




class Utility:
    def TernaryIf(condition: bool, A: T, B: T) -> T: ...
    def LikeOperator(text: str, pattern: str) -> bool: ...
    @overload
    def InvokeMethod(target: Object, method: str) -> Object: ...
    @overload
    def InvokeMethod(target: Object, method: str, params: Set(Object)) -> Object: ...
    @overload
    def InvokeMethodSafe(target: Object, method: str) -> Object: ...
    @overload
    def InvokeMethodSafe(target: Object, method: str, params: Set(Object)) -> Object: ...
    def InvokeGetter(target: Object, property: str) -> Object: ...
    def InvokeGetterSafe(target: Object, property: str) -> Object: ...
    def InvokeSetter(target: Object, property: str, value: Object) -> None: ...
    def InvokeSetterSafe(target: Object, property: str, value: Object) -> None: ...
    def InvokeDownloader(sourceUri: str, targetUri: str, silent: bool) -> None: ...
    @overload
    def FixNewlines(text: str) -> str: ...
    @overload
    def FixNewlines(text: str, newLinePattern: str) -> str: ...


class Tracing:
    @overload
    def Assert(assert_id: Guid) -> None: ...
    @overload
    def Assert(assert_id: Guid, message: str) -> None: ...
    @overload
    def Assert(assert_id: Guid, exception: Exception) -> None: ...
    @overload
    def Assert(assert_id: Guid, message: str, exception: Exception) -> None: ...
    def DebugLogBeginBlock(name: str) -> None: ...
    def DebugLogEndBlock() -> None: ...
    def DebugLogAddEntry(message: str) -> None: ...


class Versioning:
    @property
    def Version() -> GH_Version: ...
    @property
    def VersionString() -> str: ...
    @property
    def BuildDate() -> str: ...
    def SyncVersionHistoryData() -> None: ...
    def VersionHistoryData() -> Set(str): ...


class Folders:
    def ShowFolderInExplorer(folder: str) -> None: ...
    @property
    def AppDataFolder() -> str: ...
    @property
    def PluginFolder() -> str: ...
    @property
    def Desktop() -> str: ...
    @property
    def TutorialFiles() -> Set(str): ...
    @property
    def FileViewerApplication() -> str: ...
    @property
    def ImageStitcherApplication() -> str: ...
    @property
    def DownloaderApplication() -> str: ...
    @property
    def SDKDownloaderApplication() -> str: ...
    @property
    def VersionHistoryUrl() -> str: ...
    @property
    def VersionHistoryFile() -> str: ...
    @property
    def SettingsFolder() -> str: ...
    @property
    def ToolsFolder() -> str: ...
    @property
    def IconFolder() -> str: ...
    @property
    def CursorFolder() -> str: ...
    @property
    def TutorialFolder() -> str: ...
    @property
    def AutoSaveFolder() -> str: ...
    @property
    def DefaultAssemblyFolder() -> str: ...
    @property
    def DefaultAssemblyFolderVersion6() -> str: ...
    @property
    def DefaultUserObjectFolder() -> str: ...
    @property
    def DefaultClusterFolder() -> str: ...
    @property
    def DefaultTemplateFolder() -> str: ...
    @property
    def CustomAssemblyFolders() -> List: ...
    @CustomAssemblyFolders.setter
    def CustomAssemblyFolders(Value: List) -> None: ...
    @property
    def AssemblyFolders() -> List: ...
    @property
    def UserObjectFolders() -> List: ...
    @property
    def ClusterFolders() -> List: ...
    @property
    def TemplateFolders() -> List: ...


class Instances:
    def UnloadAllObjects() -> None: ...
    def ReloadMemoryAssemblies() -> List: ...
    @property
    def GrasshopperPluginId() -> Guid: ...
    @property
    def RcpPanel() -> RemoteControlPanel: ...
    @property
    def IsRemotePanelVisible() -> bool: ...
    def ShowRemotePanel() -> bool: ...
    def HideRemotePanel() -> bool: ...
    @property
    def IsDocumentEditor() -> bool: ...
    @property
    def DocumentEditor() -> GH_DocumentEditor: ...
    @property
    def EtoDocumentEditor() -> Window: ...
    @property
    def IsDocumentEditorOnTopOfViewports() -> bool: ...
    def DocumentEditorFadeOut() -> None: ...
    def DocumentEditorFadeIn() -> None: ...
    @property
    def IsCursorServer() -> bool: ...
    @property
    def CursorServer() -> GH_CursorServer: ...
    @property
    def IsComponentServer() -> bool: ...
    @property
    def ComponentServer() -> GH_ComponentServer: ...
    @property
    def IsMarkovChain() -> bool: ...
    @property
    def MarkovChain() -> GH_MarkovChain: ...
    @property
    def IsDocumentServer() -> bool: ...
    @property
    def DocumentServer() -> GH_DocumentServer: ...
    @property
    def IsDocumentAssociationServer() -> bool: ...
    @property
    def DocumentAssociationServer() -> GH_DocumentAssociations: ...
    @property
    def IsMruServer() -> bool: ...
    @property
    def MruServer() -> GH_MRU_Server: ...
    @property
    def AutoShowBanner() -> bool: ...
    @AutoShowBanner.setter
    def AutoShowBanner(AutoPropertyValue: bool) -> None: ...
    @property
    def AutoHideBanner() -> bool: ...
    @AutoHideBanner.setter
    def AutoHideBanner(AutoPropertyValue: bool) -> None: ...
    @property
    def RunningHeadless() -> bool: ...
    def add_CanvasCreated(obj: CanvasCreatedEventHandler) -> None: ...
    def remove_CanvasCreated(obj: CanvasCreatedEventHandler) -> None: ...
    def add_CanvasDestroyed(obj: CanvasDestroyedEventHandler) -> None: ...
    def remove_CanvasDestroyed(obj: CanvasDestroyedEventHandler) -> None: ...
    @property
    def ActiveCanvas() -> GH_Canvas: ...
    def InvalidateCanvas() -> None: ...
    def RedrawCanvas() -> None: ...
    def RedrawAll() -> None: ...
    @property
    def Settings() -> GH_SettingsServer: ...
    def MyTypes() -> Set(Type): ...
    def EnforceInvariantCulture() -> None: ...


class GH_InstanceServer:
    def UnloadAllObjects() -> None: ...
    def DebugLogBeginBlock(name: str) -> None: ...
    def DebugLogEndBlock() -> None: ...
    def DebugLogAddEntry(message: str) -> None: ...
    @property
    def IsDocumentEditor() -> bool: ...
    @property
    def DocumentEditor() -> GH_DocumentEditor: ...
    def DocumentEditorFadeOut() -> None: ...
    def DocumentEditorFadeIn() -> None: ...
    @property
    def IsCursorServer() -> bool: ...
    @property
    def CursorServer() -> GH_CursorServer: ...
    @property
    def IsComponentServer() -> bool: ...
    @property
    def ComponentServer() -> GH_ComponentServer: ...
    @property
    def IsMarkovChain() -> bool: ...
    @property
    def MarkovChain() -> GH_MarkovChain: ...
    @property
    def IsDocumentServer() -> bool: ...
    @property
    def DocumentServer() -> GH_DocumentServer: ...
    @property
    def IsDocumentAssociationServer() -> bool: ...
    @property
    def DocumentAssociationServer() -> GH_DocumentAssociations: ...
    @property
    def IsMruServer() -> bool: ...
    @property
    def MruServer() -> GH_MRU_Server: ...
    @property
    def ActiveCanvas() -> GH_Canvas: ...
    def InvalidateCanvas() -> None: ...
    def RedrawCanvas() -> None: ...
    def RegenCanvas() -> None: ...
    def RedrawAll() -> None: ...
    def RegenAll() -> None: ...
    @property
    def PluginDirectory() -> str: ...
    @property
    def ToolsDirectory() -> str: ...
    @property
    def DesktopDirectory() -> str: ...
    @property
    def SettingsDirectory() -> str: ...
    @property
    def Settings() -> GH_SettingsServer: ...
    def MyTypes() -> Set(Type): ...
    def EnforceInvariantCulture() -> None: ...


class Global_Proc:
    @overload
    def UiAdjust(value: int) -> int: ...
    @overload
    def UiAdjust(value: Single) -> Single: ...
    @property
    def Version() -> GH_Version: ...
    @property
    def Settings() -> GH_SettingsServer: ...


class EtoWin32Window:
    @property
    def Handle(self) -> IntPtr: ...


class AuthorNameChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class AuthorCompanyChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class AuthorCopyrightChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class AuthorAddressChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class AuthorWebsiteChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class AuthorEMailChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class AuthorPhoneChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class FormattingChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class RibbonVisibleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class RibbonAllIconsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class RibbonSeparatorsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class RibbonDrawTabIconsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class UiScaleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class TemplateFileChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class CanvasFancyWiresChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class CanvasObjectIconsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class CanvasRadialMenuChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class CanvasFullNamesChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class CanvasObsoleteTagsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class CanvasZuiZoomLevelChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class TooltipWiggleRadiusChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class PreviewMeshEdgesChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class PreviewPlaneRadiusChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class PreviewPointStyleChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class PreviewBumpZBufferChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class PreviewGumballsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class ComponentCascadeMenusChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class CreateSolutionUndoRecordChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class PruderyLevelChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class LoadProtectionChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, pluginName: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, pluginName: str) -> None: ...


class LoadMechanismChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, pluginName: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, pluginName: str) -> None: ...




class CanvasCreatedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, canvas: GH_Canvas, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, canvas: GH_Canvas) -> None: ...


class CanvasDestroyedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, canvas: GH_Canvas, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, canvas: GH_Canvas) -> None: ...
